TestCase subclass: #OperaConnectorTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-TestCases'!

!OperaConnectorTestCase methodsFor: 'testing' stamp: 'MU 3/3/2002 20:07'!
testColocationConnector
	| port msg  |
	OperaConnector useColocation: true.
	port := OperaSetting defaultPort.
	self should: [ (OperaConnector named: #local) class name = #OperaColocationConnector].
	msg := nil.
	self should: [OperaConnector default send: msg to: 'localhost' port:  port.] raise: OperaImplError. 
	msg := OperaRemoteMessage receiverName: #test selector: #testSel.
	self should: [OperaConnector default send: msg to: 'localhost' port:  port.] raise: OperaNoImplement.
	OperaORB root at: #testOrd1 put: OrderedCollection new.
	msg := OperaRemoteMessage receiverName: #testOrd1 selector: #add: argument: 1.
	self shouldnt: [OperaConnector default send: msg to: 'localhost' port:  port.] raise: OperaError.
	self should: [(OperaORB root at: #testOrd1 ) class name = #OrderedCollection].
	self should: [(OperaORB root at: #testOrd1 ) size = 1].
	OperaORB root removeKey: #testOrd1.
	OperaConnector useColocation: false.
			! !


TestCase subclass: #OperaObjectAdapterTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-TestCases'!

!OperaObjectAdapterTestCase methodsFor: 'testing' stamp: 'MU 2/23/2002 23:18'!
testDispatch
	| adapter ord message ret |
	adapter := OperaObjectAdapter new.
	ord := OrderedCollection new.
	adapter at: #rec1 put: ord.
	message := OperaRemoteMessage receiverName: #rec1 selector: #add: arguments: #(#newElem1).
	ret := adapter dispatch: message.
	self should:[ ret == #newElem1].
	! !


TestCase subclass: #OperaPortableUtilTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-TestCases'!


TestCase subclass: #OperaRemoteObjectTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-TestCases'!

!OperaRemoteObjectTestCase methodsFor: 'running' stamp: 'MU 3/31/2002 19:26'!
setUp
	OperaPortableUtil installRootOOA! !


!OperaRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 2/28/2002 16:30'!
testBasicRemoteMessageSend
	
	| remote ret |
	OperaSetting useColocation: false.
	
	OperaORB initialize.
	OperaORB root at: #testOrderedCollection put: OrderedCollection new.
	
	remote := OperaRemoteObject named: #testOrderedCollection.
	ret := remote add: #newElem1.
	self should: [ret = #newElem1].

	self should: [(OperaORB root at: #testOrderedCollection) size = 1].
	self should: [(OperaORB root at: #testOrderedCollection) first = #newElem1].
	OperaORB root removeKey: #testOrderedCollection.! !

!OperaRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 2/28/2002 17:01'!
testBasicRemoteMessageSendWithError
	
	| remote |
	OperaSetting useColocation: false.
	
	OperaORB initialize.
	OperaORB root at: #testOrderedCollection put: OrderedCollection new.
	
	remote := OperaRemoteObject named: #testOrderedCollection.
	self should: [ remote at: #kay put: #newElem1.] raise: MessageNotUnderstood.

	self shouldnt: [(OperaORB root at: #testOrderedCollection) size = 1].
	OperaORB root removeKey: #testOrderedCollection.! !

!OperaRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 2/28/2002 17:54'!
testCatNameWith
	
	| remote remoteCopy catName catName2 |
	OperaSetting useColocation: false.
	
	OperaORB initialize.
	OperaORB root at: #testServer put: OperaTestRemoteServer new.
	
	remote := OperaRemoteObject named: #testServer.
	self should:[remote isRemote].

	self shouldnt:[remote name: 'original server'] raise:MessageNotUnderstood.
	
	self shouldnt:[remoteCopy := remote returnSelfCopy] raise:MessageNotUnderstood.
	self should:[remoteCopy name = 'original server'].
	self should:[remoteCopy isTestRemoteServer].
	self shouldnt:[remoteCopy name: 'copy server'] raise:MessageNotUnderstood.

	self shouldnt:[catName := remote catNameWith: remoteCopy] raise:MessageNotUnderstood.
	self should:[catName = 'original servercopy server'].
	self should:[remoteCopy name = 'copy server'].
	
	self shouldnt:[catName2 := remote catNameWith: (OperaObjectReference on: remoteCopy)] raise:MessageNotUnderstood.
	self should:[catName2 = 'original servercopy server'].
	self should:[remoteCopy name = 'original servercopy server'].

	OperaORB root removeKey: #testServer.! !

!OperaRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 2/28/2002 16:30'!
testComplexRemoteMessageSend
	
	| remote ret |
	OperaSetting useColocation: false.
	
	OperaORB initialize.
	OperaORB root at: #testDictionary put: Dictionary new.
	
	remote := OperaRemoteObject named: #testDictionary.
	remote at: #key1 put: #newElem1.
	ret := remote at: #key2 put: #(#newElem2 #newElem3).
	self should: [ret = #(#newElem2 #newElem3)].

	self should: [(OperaORB root at: #testDictionary) values size = 2].
	self should: [((OperaORB root at: #testDictionary) at: #key2) = #(#newElem2 #newElem3)].
	OperaORB root removeKey: #testDictionary.! !

!OperaRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 2/28/2002 17:19'!
testEchoString
	
	| remote ret |
	OperaSetting useColocation: false.
	
	OperaORB initialize.
	OperaORB root at: #testServer put: OperaTestRemoteServer new.
	
	remote := OperaRemoteObject named: #testServer.
	self should:[remote isRemote].
	self shouldnt:[ret := remote echoString: 'HELLO'] raise:MessageNotUnderstood.
	self should:[ret = 'RET:HELLO'].
	
	OperaORB root removeKey: #testServer.! !

!OperaRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 2/28/2002 17:26'!
testReturnDictionary
	
	| remote ret |
	OperaSetting useColocation: false.
	
	OperaORB initialize.
	OperaORB root at: #testServer put: OperaTestRemoteServer new.
	
	remote := OperaRemoteObject named: #testServer.
	self should:[remote isRemote].
	
	self shouldnt:[ret := remote returnDictionary] raise:MessageNotUnderstood.
	self should:[ret = OperaTestRemoteServer new returnDictionary].
	
	OperaORB root removeKey: #testServer.! !

!OperaRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 2/28/2002 17:30'!
testReturnSelf
	
	| remote ret |
	OperaSetting useColocation: false.
	
	OperaORB initialize.
	OperaORB root at: #testServer put: OperaTestRemoteServer new.
	
	remote := OperaRemoteObject named: #testServer.
	self should:[remote isRemote].
	
	self shouldnt:[ret := remote returnSelf] raise:MessageNotUnderstood.
	self should:[ret isRemote].
	self should:[(ret echoString: 'HELLO') = 'RET:HELLO'].
	
	OperaORB root removeKey: #testServer.! !

!OperaRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 2/28/2002 17:35'!
testReturnSelfCopy
	
	| remote ret |
	OperaSetting useColocation: false.
	
	OperaORB initialize.
	OperaORB root at: #testServer put: OperaTestRemoteServer new.
	
	remote := OperaRemoteObject named: #testServer.
	self should:[remote isRemote].
	self shouldnt:[remote name: 'original server'] raise:MessageNotUnderstood.
	self shouldnt:[ret := remote returnSelfCopy] raise:MessageNotUnderstood.
	self should:[ret isTestRemoteServer].
	self shouldnt:[ret name: 'copied server'] raise:MessageNotUnderstood.
	self shouldnt:[remote name = ret name].
	
	OperaORB root removeKey: #testServer.! !

!OperaRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 2/28/2002 17:40'!
testReturnSelfObjectReference
	
	| remote ret |
	OperaSetting useColocation: false.
	
	OperaORB initialize.
	OperaORB root at: #testServer put: OperaTestRemoteServer new.
	
	remote := OperaRemoteObject named: #testServer.
	self should:[remote isRemote].

	self shouldnt:[remote name: 'original server'] raise:MessageNotUnderstood.
	self shouldnt:[ret := remote returnSelfObjectReference] raise:MessageNotUnderstood.
	self should:[ret isRemote].
	self shouldnt:[ret name: 'changed name'] raise:MessageNotUnderstood.
	self should:[ret name = remote name].
	
	OperaORB root removeKey: #testServer.! !


OperaRemoteObjectTestCase subclass: #OperaSqtpRemoteObjectTestCase
	instanceVariableNames: 'originalTransport originalRunningTransports '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-TestCases'!

!OperaSqtpRemoteObjectTestCase methodsFor: 'running' stamp: 'MU 4/18/2003 17:21'!
setUp
	super setUp.
	originalTransport := OperaSetting defaultTransport.
	originalRunningTransports := SoapServerSetup runningTransportNames.
	OperaSetting defaultTransport: #sqtp.
	SoapServerSetup startOnly: #(sqtp)! !

!OperaSqtpRemoteObjectTestCase methodsFor: 'running' stamp: 'MU 4/18/2003 17:21'!
tearDown
	super tearDown.
	OperaSetting defaultTransport: originalTransport.
	SoapServerSetup startOnly: originalRunningTransports! !


!OperaSqtpRemoteObjectTestCase methodsFor: 'testing' stamp: 'MU 4/18/2003 17:21'!
testCurrntTransportSetting
	self should: [OperaSetting defaultTransport == #sqtp].
	self should: [SoapServerSetup runningTransportNames includes: #sqtp]! !


Object subclass: #OperaTestRemoteServer
	instanceVariableNames: 'name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Opera-TestCases'!

!OperaTestRemoteServer methodsFor: 'actions' stamp: 'MU 2/28/2002 17:51'!
catNameWith: anOperaTestRemoteServer
	| newName |
	newName :=  self name, anOperaTestRemoteServer name.
	anOperaTestRemoteServer name: newName.
	^newName! !

!OperaTestRemoteServer methodsFor: 'actions' stamp: 'MU 2/28/2002 17:07'!
echoString: aString
	^'RET:',aString! !

!OperaTestRemoteServer methodsFor: 'actions' stamp: 'MU 2/28/2002 17:15'!
returnDictionary
	| dict |
	dict := Dictionary new.
	dict at: #a put: 'some data'.
	dict at: #b put: 20.
	dict at: #c put: #(1 2 3 'we love smalltalk' #(4.0 10/2)).
	^ dict! !

!OperaTestRemoteServer methodsFor: 'actions' stamp: 'MU 2/28/2002 17:09'!
returnSelf
	^self! !

!OperaTestRemoteServer methodsFor: 'actions' stamp: 'MU 2/28/2002 17:09'!
returnSelfCopy
	^self copy! !

!OperaTestRemoteServer methodsFor: 'actions' stamp: 'MU 2/28/2002 17:12'!
returnSelfObjectReference

	^OperaObjectReference on: self! !


!OperaTestRemoteServer methodsFor: 'accessing' stamp: 'MU 2/28/2002 17:10'!
name
	^name! !

!OperaTestRemoteServer methodsFor: 'accessing' stamp: 'MU 2/28/2002 17:10'!
name: aString
	name := aString
! !


!OperaTestRemoteServer methodsFor: 'testing' stamp: 'MU 2/28/2002 17:34'!
isTestRemoteServer
	^true! !
