'From Squeak3.4gamma of ''7 January 2003'' [latest update: #5168] on 18 March 2003 at 6:37:45 pm'!

!Object methodsFor: 'initializing-sixx' stamp: 'MU 10/27/2002 18:37'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]].
	self class isVariable
		ifTrue: [| idx nonameElems  | 
			idx := 1.
			nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
						select: [:each | (self class nameFromSixxElement: each) isNil].
			nonameElems isEmpty
				ifFalse: [(SixxXmlUtil elementsFrom: nonameElems first)
						do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
								ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
									self at: idx put: childInst.
									idx := idx + 1]]]]! !

!Object methodsFor: 'initializing-sixx' stamp: 'MU 6/9/2002 19:30'!
sixxInstVarNamed: instVarName put: aValue 
	"override if you like"
	self
		instVarAt: (self class allInstVarNames indexOf: instVarName asString)
		put: aValue! !

!Object methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:34'!
sixxContentOn: aStream indent: level context: dictionary
	"override if you like"
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.
! !

!Object methodsFor: 'printing-sixx' stamp: 'kuri-t 5/17/2002 14:27'!
sixxOn: aStream 
	self sixxOn: aStream indent: 0 context: IdentityDictionary new! !

!Object methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxOn: aStream indent: level context: dictionary
	^self sixxOn: aStream name: nil indent: level context: dictionary! !

!Object methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	aStream tab: level.
	(dictionary includesKey: self)
		ifTrue: [aStream
				nextPutAll: (self
						sixxRefTagStartString: (dictionary at: self) name: nameString)]
		ifFalse: [| idStr | 
			idStr := dictionary size asString.			
			dictionary at: self put: idStr.
			aStream
				nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !

!Object methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:34'!
sixxString
	| wStr |
	wStr := (String new: 128) writeStream.
	self sixxOn: wStr.
	^wStr contents! !

!Object methodsFor: 'private-sixx' stamp: 'MU 10/20/2002 02:31'!
sixxAllContentsOn: aStream indent: level context: dictionary
	self sixxInstVarsOn: aStream indent: level context: dictionary.
	self sixxElementsOn: aStream indent: level context: dictionary.! !

!Object methodsFor: 'private-sixx' stamp: 'MU 10/20/2002 02:40'!
sixxChildrenContentsFixedOn: aStream indent: level context: dictionary
	self sixxInstVarsOn: aStream indent: level context: dictionary! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:34'!
sixxChildrenContentsOn: aStream indent: level context: dictionary
	self class isVariable
		ifTrue: [self sixxChildrenContentsVariableOn: aStream indent: level context: dictionary]
		ifFalse: 
			[self sixxChildrenContentsFixedOn: aStream indent: level context: dictionary ].
! !

!Object methodsFor: 'private-sixx' stamp: 'MU 10/20/2002 02:35'!
sixxChildrenContentsVariableOn: aStream indent: level context: dictionary
	self class isBits 
		ifTrue: 
			[aStream nextPutAll: '#( '.
			self do: 
					[:each | 
					aStream
						nextPutAll: each asString;
						space].
			aStream nextPutAll: ')']
		ifFalse: 
			[self 
				sixxAllContentsOn: aStream
				indent: level
				context: dictionary]! !

!Object methodsFor: 'private-sixx' stamp: 'MU 10/21/2002 01:01'!
sixxElementsOn: aStream indent: level context: dictionary 
	"override if you like"
	| size array |
	size := self basicSize.
	size = 0
				ifTrue: [^ self].
	array := Array new: size.
	1
		to: size
		do: [:i | 
			| element | 
			element := self basicAt: i.
			array at: i put: element].
	array
		sixxOn: aStream
		indent: level
		context: dictionary! !

!Object methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 15:45'!
sixxEnv
	^SixxPortableUtil environmentQualifierOf: self class! !

!Object methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 15:45'!
sixxEnvAttribString
	^'sixx.env="' , self sixxEnv , '" '! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxIdAttribString: idString
	^'sixx.id="', idString asString, '" '! !

!Object methodsFor: 'private-sixx' stamp: 'MU 10/20/2002 02:30'!
sixxInstVarsOn: aStream indent: level context: dictionary
	| instVars ind |
	aStream cr.
	instVars := self class allInstVarNames.
	ind := 0.
	instVars do: 
			[:nm | 
			ind := ind + 1.
			(self instVarAt: ind) 
				sixxOn: aStream
				name: nm
				indent: level
				context: dictionary]! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxNameAttribString: idString
	^'sixx.name="', idString asString, '" '! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxRefTagStartString: idString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	idString isNil
		ifFalse: [wStr
				nextPutAll: idString].
	wStr nextPutAll: '" >'.
	^ wStr contents! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxRefTagStartString: idString name: nameString 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object sixx.idref="'.
	wStr nextPutAll: idString.
	wStr nextPutAll: '" '.
	nameString notNil
		ifTrue: [wStr nextPutAll: 'sixx.name="'.
			wStr nextPutAll: nameString.
			wStr nextPutAll: '" '].
	wStr nextPutAll: '>'.
	^ wStr contents! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxTagEndString
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '</sixx.object>'.
	^wStr contents
	! !

!Object methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 15:47'!
sixxTagStartString: idString name: nameString 
	| wStr |
	wStr := (String new: 16) writeStream.
	wStr nextPutAll: '<sixx.object '.
	idString isNil
		ifFalse: [wStr
				nextPutAll: (self sixxIdAttribString: idString)].
	nameString isNil
		ifFalse: [wStr
				nextPutAll: (self sixxNameAttribString: nameString)].
	wStr nextPutAll: self sixxTypeAttribString.
	SixxSetting useEnvironment ifTrue: [wStr nextPutAll: self sixxEnvAttribString.].
	wStr nextPutAll: '>'.
	^ wStr contents! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxType
	^self class name! !

!Object methodsFor: 'private-sixx' stamp: 'mu 5/10/2002 14:35'!
sixxTypeAttribString
	^'sixx.type="', self sixxType, '" '! !


!Behavior methodsFor: 'instance creation-sixx' stamp: 'MU 10/27/2002 18:26'!
createInstanceOf: aClass withSixxElement: sixxElement 
	"override if you like"
	^ aClass isVariable
		ifTrue: [| nonameElems size | 
			nonameElems := (SixxXmlUtil elementsFrom: sixxElement)
						select: [:each | (self nameFromSixxElement: each) isNil].
			size := nonameElems isEmpty
						ifTrue: [0]
						ifFalse: [(SixxXmlUtil elementsFrom: nonameElems first) size].
			aClass new: size]
		ifFalse: [aClass new]! !

!Behavior methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/20/2002 14:05'!
readSixxFrom: xmlStringOrStream 
	^ self readSixxFrom: xmlStringOrStream context: IdentityDictionary new! !

!Behavior methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/20/2002 14:04'!
readSixxFrom: xmlStringOrStream context: aDictionary 
	| topElem |
	topElem := SixxXmlUtil parseXml: xmlStringOrStream.
	^ self readSixxFromSixxElement: topElem context: aDictionary! !

!Behavior methodsFor: 'instance creation-sixx' stamp: 'kuri-t 6/3/2002 16:29'!
readSixxFromSixxElement: sixxElement context: aDictionary 
	| rootClass typeAttr |
	typeAttr := self typeFromSixxElement: sixxElement.
	^typeAttr isNil
		ifTrue: [(self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
				ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]]
		ifFalse: [rootClass := self classFromSixxElement: sixxElement context: aDictionary.
			rootClass isNil
				ifFalse: [rootClass fromSixxElement: sixxElement context: aDictionary]]! !

!Behavior methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 12:57'!
classFromSixxElement: sixxElement context: dictionary 
	| isClassClass type className retClass |
	isClassClass := false.
	type := self typeFromSixxElement: sixxElement.
	type isNil
		ifTrue: [^ nil].
	className := (type includes: Character space)
				ifTrue: [isClassClass := true.
					type copyUpTo: Character space]
				ifFalse: [type].
	retClass := SixxPortableUtil
				classAt: className
				in: (self envFromSixxElement: sixxElement).
	isClassClass
		ifTrue: [retClass := retClass class].
	^ retClass isNil
		ifTrue: [SixxClassNotFound
				signal: className
				element: sixxElement
				context: dictionary]
		ifFalse: [retClass]! !

!Behavior methodsFor: 'private-sixx' stamp: 'MU 3/6/2003 12:57'!
envFromSixxElement: sixxElement 
	| environmentQualifier |
	(SixxXmlUtil isTextFrom: sixxElement)
		ifTrue: [^ nil].
	environmentQualifier := SixxXmlUtil attributeAt: #'sixx.env' from: sixxElement.
	^ environmentQualifier isNil
		ifFalse: [environmentQualifier asSymbol]! !

!Behavior methodsFor: 'private-sixx' stamp: 'MU 5/31/2002 15:21'!
fromSixxElement: sixxElement context: aDictionary 
	^ (self includesRefInstanceFromSixxElement: sixxElement context: aDictionary)
		ifTrue: [self refInstanceFromSixxElement: sixxElement context: aDictionary]
		ifFalse: [self newInstanceFromSixxElement: sixxElement context: aDictionary]! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/15/2002 18:10'!
idFromSixxElement: sixxElement 
	| id |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	id := SixxXmlUtil attributeAt: #'sixx.id' from: sixxElement .
	^ id isNil
		ifFalse: [id asSymbol]! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/15/2002 18:10'!
idrefFromSixxElement: sixxElement
	| idref |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	idref := SixxXmlUtil attributeAt: #'sixx.idref' from: sixxElement .
	^ idref isNil
		ifFalse: [idref asSymbol]! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 6/3/2002 16:06'!
includesRefInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^ idref isNil
		ifTrue: [false]
		ifFalse: [aDictionary includesKey: idref]! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/15/2002 18:10'!
nameFromSixxElement: sixxElement 
	| nm |
	(SixxXmlUtil isTextFrom: sixxElement) ifTrue: [^nil].
	nm := SixxXmlUtil attributeAt: #'sixx.name' from: sixxElement .
	^ nm isNil
		ifFalse: [nm asSymbol]! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 6/3/2002 14:28'!
newInstanceFromSixxElement: sixxElement context: aDictionary 
	| class inst |
	class := self classFromSixxElement: sixxElement context: aDictionary .
	class isNil
		ifTrue: [SixxClassNotFound
				signal: (self typeFromSixxElement: sixxElement)
				element: sixxElement
				context: aDictionary].
	inst := class createInstanceOf: class withSixxElement: sixxElement.
	aDictionary
		at: (self idFromSixxElement: sixxElement)
		put: inst.
	inst initializeFromSixxElement: sixxElement context: aDictionary.
	^ inst! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/14/2002 19:43'!
refInstanceFromSixxElement: sixxElement context: aDictionary 
	| idref |
	idref := self idrefFromSixxElement: sixxElement.
	^aDictionary at: idref! !

!Behavior methodsFor: 'private-sixx' stamp: 'kuri-t 5/15/2002 18:10'!
typeFromSixxElement: sixxElement 
	| type |
	(SixxXmlUtil isTextFrom: sixxElement)
		ifTrue: [^ nil].
	type := SixxXmlUtil attributeAt: #'sixx.type' from: sixxElement.
	^ type isNil
		ifFalse: [type asSymbol]! !


!Boolean methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 16:20'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !


!Character methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:37'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString
	! !


!ClassDescription methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:32'!
sixxContentOn: aStream indent: level context: dictionary
	| instVars startIndex  |	
	aStream cr.
	instVars := self class allInstVarNames.
	startIndex := Object class allInstVarNames size + 1.
	startIndex to: instVars size do: [:idx | 
			(self instVarAt: idx)
				sixxOn: aStream
				name: (instVars at: idx)
				indent: level + 1
				context: dictionary].! !


!Boolean class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:06'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !


!Character class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:06'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !


!Collection methodsFor: 'initializing-sixx' stamp: 'kuri-t 5/15/2002 18:43'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | 
			| childInst | 
			childInst := self class fromSixxElement: elem context: aDictionary.
			self add: childInst]! !

!Collection methodsFor: 'printing-sixx' stamp: 'kuri-t 5/13/2002 11:35'!
sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self
		do: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level.! !

!Collection methodsFor: 'private-sixx' stamp: 'MU 10/20/2002 02:38'!
sixxAllContentsOn: aStream indent: level context: dictionary
	"Usually Collection's inst vars are not needed for serialization"
	self sixxElementsOn: aStream indent: level context: dictionary.! !

!Collection methodsFor: 'private-sixx' stamp: 'MU 10/20/2002 02:59'!
sixxElementsOn: aStream indent: level context: dictionary
	"override if you like"
	self size = 0 ifTrue: [^self].
	aStream cr.
	self do: 
			[:each | 
			each 
				sixxOn: aStream
				indent: level
				context: dictionary]

! !


!ArrayedCollection methodsFor: 'initializing-sixx' stamp: 'kuri-t 5/31/2002 17:43'!
initializeFromSixxElement: sixxElement context: aDictionary 
	| idx |
	idx := 1.
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | childInst | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [childInst := self class fromSixxElement: elem context: aDictionary.
					self at: idx put: childInst.
					idx := idx + 1]]! !


!ByteArray methodsFor: 'printing-sixx' stamp: 'MU 6/29/2002 15:57'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !


!Collection class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:08'!
createInstanceOf: aClass withSixxElement: sixxElement
	"override if you like"
	^aClass new: (SixxXmlUtil elementsFrom: sixxElement) size! !


!ByteArray class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 6/3/2002 17:34'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (SixxXmlUtil characterDataFrom: sixxElement).
	^ col asByteArray! !


!Date methodsFor: 'printing-sixx' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !


!Date class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:06'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self
		readFrom: (ReadStream
				on: (SixxXmlUtil characterDataFrom: sixxElement))! !


!Dictionary methodsFor: 'printing-six' stamp: 'mu 5/10/2002 14:33'!
sixxContentOn: aStream indent: level context: dictionary
	aStream cr.
	self
		associationsDo: [:each | each
				sixxOn: aStream
				indent: level + 1
				context: dictionary].
	aStream tab: level.! !


!Interval methodsFor: 'printing-sixx' stamp: 'minami 3/18/2003 01:47'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self printString! !


!Interval class methodsFor: 'instance creation-sixx' stamp: 'minami 3/18/2003 01:34'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self
		readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !


!Metaclass methodsFor: 'instance creation-sixx' stamp: 'MU 9/2/2002 02:46'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ aClass isMeta
		ifTrue: [aClass soleInstance]
		ifFalse: [aClass]! !


!Number methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:36'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self asString
	! !


!Number class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:06'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ (SixxXmlUtil characterDataFrom: sixxElement) asNumber
	! !


!Point methodsFor: 'printing-sixx' stamp: 'kuri-t 6/3/2002 16:52'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: self storeString! !


!Point class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 6/3/2002 16:57'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !


!RunArray methodsFor: 'initializing-sixx' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst]]]! !

!RunArray methodsFor: 'printing-sixx' stamp: 'MU 7/9/2002 01:25'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream cr.
	self runs
		sixxOn: aStream
		name: 'runs'
		indent: level + 1
		context: dictionary.
	self values
		sixxOn: aStream
		name: 'values'
		indent: level + 1
		context: dictionary.
	aStream tab: level! !


!RunArray class methodsFor: 'instance creation-sixx' stamp: 'MU 7/21/2002 23:30'!
createInstanceOf: aClass withSixxElement: sixxElement
	"squeak specific"
	
	^aClass basicNew! !


!String methodsFor: 'printing-sixx' stamp: 'MU 9/16/2002 20:04'!
sixxContentOn: aStream indent: level context: dictionary
	SixxXmlUtil writeXmlText: self on: aStream! !


!String class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:07'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ SixxXmlUtil characterDataFrom: sixxElement! !


!Symbol class methodsFor: 'instance creation-sixx' stamp: 'mu 5/9/2002 17:46'!
createInstanceOf: aClass withSixxElement: sixxElement
	^(super createInstanceOf: aClass withSixxElement: sixxElement) asSymbol! !


!Text methodsFor: 'initializing-sixx' stamp: 'MU 7/21/2002 23:35'!
initializeFromSixxElement: sixxElement context: aDictionary 
	(SixxXmlUtil elementsFrom: sixxElement)
		do: [:elem | | varName | (SixxXmlUtil isTextFrom: elem)
				ifFalse: [varName := self class nameFromSixxElement: elem.
					varName notNil
						ifTrue: [| childInst | 
							childInst := self class fromSixxElement: elem context: aDictionary.
							self sixxInstVarNamed: varName put: childInst ]]]! !

!Text methodsFor: 'printing-sixx' stamp: 'MU 7/9/2002 01:11'!
sixxContentOn: aStream indent: level context: dictionary
	self sixxChildrenContentsOn: aStream indent: level + 1 context: dictionary.
	aStream tab: level.! !


!Time methodsFor: 'printing-sixx' stamp: 'MU 9/16/2002 22:29'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self sixxContentString! !


!Time class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:07'!
createInstanceOf: aClass withSixxElement: sixxElement 
	^ self
		readFrom: (ReadStream
				on: (SixxXmlUtil characterDataFrom: sixxElement))! !


!UndefinedObject methodsFor: 'printing-sixx' stamp: 'mu 5/10/2002 14:36'!
sixxContentOn: aStream indent: level context: dictionary
	aStream nextPutAll: self storeString! !

!UndefinedObject methodsFor: 'printing-sixx' stamp: 'MU 9/16/2002 18:56'!
sixxOn: aStream name: nameString indent: level context: dictionary 
	| key |
	key := self asSixxKey.
	aStream tab: level.
	(dictionary includesKey: key )
		ifTrue: [aStream
				nextPutAll: (self
						sixxRefTagStartString: (dictionary at: key) name: nameString)]
		ifFalse: [| idStr | 
			idStr := dictionary size asString.			
			dictionary at: key put: idStr.
			aStream
				nextPutAll: (self sixxTagStartString: idStr name: nameString).
			self
				sixxContentOn: aStream
				indent: level
				context: dictionary].
	aStream nextPutAll: self sixxTagEndString.
	aStream cr! !

!UndefinedObject methodsFor: 'private-sixx' stamp: 'MU 9/16/2002 18:55'!
asSixxKey
	"For some Smalltalks which do not support nil element in IdentityDictionary"
	^#'SIXX-UndefinedObject(98ea8c30-2bf8-4d23-9da2-ad1ee0e29eff)'
! !


!UndefinedObject class methodsFor: 'instance creation-sixx' stamp: 'kuri-t 5/15/2002 18:07'!
createInstanceOf: aClass withSixxElement: sixxElement
	^ self readFrom: (SixxXmlUtil characterDataFrom: sixxElement)! !


!WordArray methodsFor: 'printing-sixx' stamp: 'MU 6/29/2002 16:00'!
sixxContentOn: aStream indent: level context: dictionary 
	aStream nextPutAll: '#( '.
	self do:[:each | aStream nextPutAll: each printString; space].
	aStream nextPutAll: ')'.! !


!WordArray class methodsFor: 'instance creation-sixx' stamp: 'MU 6/29/2002 16:00'!
createInstanceOf: aClass withSixxElement: sixxElement 
	| col |
	col := Array readFrom: (SixxXmlUtil characterDataFrom: sixxElement).
	^ col asWordArray! !


!Date reorganize!
('accessing' day julianDayNumber julianDayNumber: leap monthIndex monthName weekday weekdayIndex year)
('arithmetic' addDays: subtractDate: subtractDays:)
('comparing' < = hash)
('inquiries' dayOfMonth dayOfYear daylightSavingsInEffect daylightSavingsInEffectAtStandardHour: daysInMonth daysInYear daysLeftInYear firstDayOfMonth next previous previous:)
('converting' asDate asGregorian asJulianDayNumber asSeconds dayMonthYearDo: month week)
('printing' mmddyyyy printFormat: printOn: printOn:format: storeOn: uniqueDateStringBetween:and: yyyymmdd)
('obsolete' day:year: firstDayOfMonthIndex: mmddyy)
('testing')
('printing-sixx' sixxContentOn:indent:context:)
('private-sixx' sixxContentString)
!

