Object subclass: #SixxPortableUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIXX-Squeak'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SixxPortableUtil class
	instanceVariableNames: 'setting '!

!SixxPortableUtil class methodsFor: 'class initialization' stamp: 'MU 3/18/2003 18:27'!
initialize
	setting := nil! !

!SixxPortableUtil class methodsFor: 'class initialization' stamp: 'MU 3/18/2003 18:32'!
obsolete
	self initialize! !


!SixxPortableUtil class methodsFor: 'accessing' stamp: 'MU 3/18/2003 18:32'!
setting
	setting isNil
		ifTrue: [setting := Smalltalk
						at: #SixxSetting
						ifAbsent: [self error: 'SixxSetting is needed to run SIXX']].
	^ setting! !


!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 3/18/2003 18:29'!
classAt: localClassName in: environmentQualifier 
	"#Squeak Specific#"
	| foundClass classNameSymbol |
	foundClass := nil.
	classNameSymbol := localClassName asSymbol.
	foundClass := self setting useEnvironment
				ifTrue: [| env | 
					env := environmentQualifier isNil
								ifTrue: [Smalltalk]
								ifFalse: ["Currently Squeak does not support  
									namespace, so just ignore"
									Smalltalk].
					env
						at: classNameSymbol
						ifAbsent: []]
				ifFalse: [Smalltalk
						at: classNameSymbol
						ifAbsent: []].
	^ foundClass! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 3/6/2003 15:55'!
environmentQualifierOf: aClass
	"#Squeak Specific#"
	"Currently Squeak does not support namespace, so just ignore"
	^'Smalltalk'! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 6/11/2002 12:29'!
readFileStreamNamed: aFilename
	"#Squeak Specific#"
	^CrLfFileStream readOnlyFileNamed: aFilename.! !

!SixxPortableUtil class methodsFor: 'actions' stamp: 'MU 6/11/2002 12:35'!
writeFileStreamNamed: aFilename
	"#Squeak Specific#"
	^CrLfFileStream newFileNamed: aFilename.! !

SixxPortableUtil initialize!