SoXmlAttributesHolder subclass: #SoapAttributesHolder
	instanceVariableNames: 'encodingStyle '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!
!SoapAttributesHolder commentStamp: '<historical>' prior: 0!
A Container for XML attributes.


---
mu 5/21/2001 22:24!


!SoapAttributesHolder methodsFor: 'actions' stamp: 'mu 5/6/2001 01:32'!
putAttributeNamed: attribName value: attribValue
	| encs |
	"ToDo: take a more serious approach...Namespace conscious"
	encs := SoapConstants encodingStyle.
	('*:', encs match: attribName) ifTrue: [self encodingStyle: attribValue].
	super putAttributeNamed: attribName value: attribValue.
	! !


!SoapAttributesHolder methodsFor: 'accessing' stamp: 'mu 5/6/2001 01:32'!
encodingStyle
	^encodingStyle! !

!SoapAttributesHolder methodsFor: 'accessing' stamp: 'mu 5/6/2001 01:33'!
encodingStyle: aString
	encodingStyle := aString! !


Object subclass: #SoapConfigurationMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapConfigurationMap class
	instanceVariableNames: 'implDict '!

!SoapConfigurationMap class methodsFor: 'class initialization' stamp: 'mu 5/1/2003 17:18'!
initImplDict
	implDict := nil! !

!SoapConfigurationMap class methodsFor: 'class initialization' stamp: 'mu 5/1/2003 17:20'!
initialize
	"SoapConfigurationMap initialize"
	
	self initImplDict.
	
	Smalltalk at: self rootImplClassName ifPresent:[:found | found initializeAll].
	! !

!SoapConfigurationMap class methodsFor: 'class initialization' stamp: 'mu 5/26/2003 23:23'!
initializeAll
	"SoapConfigurationMap initializeAll"
	
	self allSubclassesDo:[:each | each initialize]! !


!SoapConfigurationMap class methodsFor: 'actions' stamp: 'mu 5/1/2003 17:39'!
at: aSymbol
	^self implDict at: aSymbol ifAbsent:[].
	! !

!SoapConfigurationMap class methodsFor: 'actions' stamp: 'mu 5/1/2003 17:24'!
at: aSymbol put: realClass
	^self implDict at: aSymbol put: realClass! !

!SoapConfigurationMap class methodsFor: 'actions' stamp: 'mu 5/1/2003 17:40'!
removeAt: aSymbol
	^self implDict removeKey: aSymbol ifAbsent:[]! !


!SoapConfigurationMap class methodsFor: 'accessing' stamp: 'mu 5/1/2003 17:19'!
implDict
	implDict isNil ifTrue: [implDict :=  IdentityDictionary new].
	^implDict! !


!SoapConfigurationMap class methodsFor: 'factory' stamp: 'mu 5/1/2003 17:20'!
rootImplClassName
	"subclass should return a class name"
	^nil! !


!SoapConfigurationMap class methodsFor: 'utility' stamp: 'mu 5/26/2003 23:24'!
isKom6plus
	^Smalltalk includesKey: #HttpService! !

!SoapConfigurationMap class methodsFor: 'utility' stamp: 'mu 5/26/2003 23:24'!
isNG
	^Smalltalk includesKey: #ComancheHttpService! !


SoXmlConstants subclass: #SoapConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!
!SoapConstants commentStamp: '<historical>' prior: 0!
SOAP Constants provider.

(I hate to use Pool)
---
mu 5/3/2001 19:32!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapConstants class
	instanceVariableNames: ''!

!SoapConstants class methodsFor: 'URIs' stamp: 'MU 10/14/2002 23:57'!
nullEncURI
	"non standard squeak specific encoding - MU"
	^ self at: #soapNullEncURI ifAbsentPutValue: 'http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/null/encoding/'! !

!SoapConstants class methodsFor: 'URIs' stamp: 'mu 6/13/2001 00:21'!
soapActorNextURI
	^self at: #soapActorNextURI ifAbsentPutValue:'http://schemas.xmlsoap.org/soap/actor/next' ! !

!SoapConstants class methodsFor: 'URIs' stamp: 'MU 3/9/2002 01:03'!
soapEncURI
	"ToDo: swith 1.2 value: http://www.w3.org/2001/12/soap-encoding"
	^self at: #soapEncURI ifAbsentPutValue:'http://schemas.xmlsoap.org/soap/encoding/' ! !

!SoapConstants class methodsFor: 'URIs' stamp: 'mu 6/13/2001 00:21'!
soapEnvURI
	^self at: #soapEnvURI ifAbsentPutValue:'http://schemas.xmlsoap.org/soap/envelope/' ! !

!SoapConstants class methodsFor: 'URIs' stamp: 'MU 6/29/2002 15:08'!
soapSixxEncURI
	"sixx encoding - MU"
	^ self at: #soapSixxEncURI ifAbsentPutValue: 'http://www.mars.dti.ne.jp/~umejava/smalltalk/sixx/encoding/'! !

!SoapConstants class methodsFor: 'URIs' stamp: 'mu 6/28/2001 00:41'!
soapSqEncURI
	"non standard squeak specific encoding - MU"
	^ self at: #soapSqEncURI ifAbsentPutValue: 'http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/encoding/'! !

!SoapConstants class methodsFor: 'URIs' stamp: 'MU 6/29/2002 15:08'!
soapSrpEncURI
	"camp smalltalk SRP encoding - MU"
	^ self at: #srpEncURI ifAbsentPutValue: 'http://wiki.cs.uiuc.edu/CampSmalltalk/SRP/encoding/'! !


!SoapConstants class methodsFor: 'prefixes' stamp: 'MU 10/14/2002 23:58'!
nullEncPrefix
	^self at: #nullEncPrefix ifAbsentPutValue:'Null-ENC' ! !

!SoapConstants class methodsFor: 'prefixes' stamp: 'MU 10/14/2002 23:59'!
nullEncPrefixColon
	^self withColon: self nullEncPrefix! !

!SoapConstants class methodsFor: 'prefixes' stamp: 'mu 1/9/2002 02:00'!
soapEncPrefix
	^self at: #soapEncPrefix ifAbsentPutValue:'enc' ! !

!SoapConstants class methodsFor: 'prefixes' stamp: 'mu 4/15/2001 02:01'!
soapEncPrefixColon
	^self withColon: self soapEncPrefix! !

!SoapConstants class methodsFor: 'prefixes' stamp: 'mu 1/9/2002 02:03'!
soapEnvPrefix
	^self at: #soapEnvPrefix ifAbsentPutValue:'env' ! !

!SoapConstants class methodsFor: 'prefixes' stamp: 'mu 4/15/2001 02:01'!
soapEnvPrefixColon
	^self withColon: self soapEnvPrefix! !

!SoapConstants class methodsFor: 'prefixes' stamp: 'mu 7/1/2001 23:56'!
sqEncPrefix
	^self at: #sqEncPrefix ifAbsentPutValue:'Squeak-ENC' ! !

!SoapConstants class methodsFor: 'prefixes' stamp: 'mu 7/1/2001 23:56'!
sqEncPrefixColon
	^self withColon: self sqEncPrefix! !


!SoapConstants class methodsFor: 'attributes' stamp: 'mu 6/13/2001 00:21'!
actor
	^self at: #actor ifAbsentPutValue:'actor' 
  ! !

!SoapConstants class methodsFor: 'attributes' stamp: 'MU 3/24/2002 00:01'!
arrayType
	
	^self at: #arrayType ifAbsentPutValue: (self soapEncPrefixColon, 'arrayType')! !

!SoapConstants class methodsFor: 'attributes' stamp: 'mu 6/13/2001 00:20'!
encodingStyle
	^self at: #encodingStyle ifAbsentPutValue:'encodingStyle' 
  ! !

!SoapConstants class methodsFor: 'attributes' stamp: 'MU 1/8/2003 01:49'!
href
	^self at: #href ifAbsentPutValue:'href' 
  ! !

!SoapConstants class methodsFor: 'attributes' stamp: 'MU 1/8/2003 01:49'!
id
	^self at: #id ifAbsentPutValue:'id' 
  ! !

!SoapConstants class methodsFor: 'attributes' stamp: 'MU 3/23/2002 23:53'!
xsiNil
	"shortcut for performance"
	"xsi:null is Soap1.1"
	"xsi:nil is Soap1.2"
	^self at: #xsiNil ifAbsentPutValue: (self xsiPrefixColon, 'nil')! !


!SoapConstants class methodsFor: 'fault codes' stamp: 'mu 6/13/2001 00:21'!
client
	^self at: #client ifAbsentPutValue:'Client' 
! !

!SoapConstants class methodsFor: 'fault codes' stamp: 'mu 6/13/2001 00:21'!
mustUnderstand
	^self at: #mustUnderstand ifAbsentPutValue:'MustUnderstand' 

! !

!SoapConstants class methodsFor: 'fault codes' stamp: 'mu 6/13/2001 00:21'!
server
	^self at: #server ifAbsentPutValue:'Server' 
! !

!SoapConstants class methodsFor: 'fault codes' stamp: 'mu 6/13/2001 00:21'!
versionMismatch
	^self at: #versionMismatch ifAbsentPutValue:'VersionMismatch' ! !


!SoapConstants class methodsFor: 'rpc' stamp: 'mu 1/1/2002 20:31'!
returnValueAccessor
	^self at: #returnValueAccessor ifAbsentPutValue:'result' 
! !


Object subclass: #SoapEnvelopeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!

!SoapEnvelopeBuilder methodsFor: 'actions' stamp: 'mu 12/28/2001 00:24'!
buildClientSoapFaultEnvelope: anError 
	| env fault builder |
	env := SoapEnvelope new.
	fault := env addBody addFault client.
	builder := SoapFaultDetailBuilder new.
	builder buildSoapFaultDetailOn: fault from: anError.
	^ env! !

!SoapEnvelopeBuilder methodsFor: 'actions' stamp: 'MU 3/1/2002 19:20'!
buildServerSoapFaultEnvelope: anError 
	| env fault builder |
	env := SoapEnvelope new.
	fault := env addBody addFault server.
	builder := SoapFaultDetailBuilder new.
	builder buildSoapFaultDetailOn: fault from: anError.
	^ env! !

!SoapEnvelopeBuilder methodsFor: 'actions' stamp: 'MU 3/1/2002 19:36'!
buildSoapEnvelopeFromXmlString: anXmlString 
	[| elem envelope | 
	elem := SoapWrapElement fromXml: anXmlString.
	envelope :=  SoapEnvelope fromXmlElement: elem.
	envelope declareTypicalNamespaces.
	^envelope]
		on: Error
		do: [:ex | ^ self buildServerSoapFaultEnvelope: ex]! !


Error subclass: #SoapError
	instanceVariableNames: 'faultcode faultstring detail '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!
!SoapError commentStamp: '<historical>' prior: 0!
SOAP Abstract Error class
---
mu 5/21/2001 22:30!


!SoapError methodsFor: 'accessing' stamp: 'MU 5/3/2002 02:03'!
detail
	^detail! !

!SoapError methodsFor: 'accessing' stamp: 'MU 5/3/2002 02:03'!
detail: aValue
	detail :=  aValue! !

!SoapError methodsFor: 'accessing' stamp: 'MU 11/2/2000 23:32'!
faultCode
	^faultCode! !

!SoapError methodsFor: 'accessing' stamp: 'MU 11/2/2000 23:31'!
faultCode: aValue
	faultCode := aValue! !

!SoapError methodsFor: 'accessing' stamp: 'MU 5/3/2002 02:02'!
faultcode
	^faultcode! !

!SoapError methodsFor: 'accessing' stamp: 'MU 5/3/2002 02:02'!
faultcode: aValue
	faultcode := aValue! !

!SoapError methodsFor: 'accessing' stamp: 'MU 5/3/2002 02:03'!
faultstring
	^faultstring! !

!SoapError methodsFor: 'accessing' stamp: 'MU 5/3/2002 02:03'!
faultstring: aValue
	faultstring := aValue! !


!SoapError methodsFor: 'exceptionDescription' stamp: 'MU 5/3/2002 02:08'!
description
	| desc |
	desc := super description.
	self faultcode isNil ifFalse: [desc := desc, ':', self faultcode].
	self faultstring isNil ifFalse: [desc := desc, '#', self faultstring].
	^desc! !

!SoapError methodsFor: 'exceptionDescription' stamp: 'mu 11/10/2001 18:50'!
isResumable
	
	^ true! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapError class
	instanceVariableNames: ''!

!SoapError class methodsFor: 'instance creation' stamp: 'MU 5/3/2002 02:04'!
faultcode: aFaultCodeSymbol
	^self new faultcode: aFaultCodeSymbol! !

!SoapError class methodsFor: 'instance creation' stamp: 'MU 5/3/2002 02:00'!
fromSoapFault: aSoapFault
	| inst |
	inst := self faultcode: aSoapFault faultcode.
	inst faultstring: aSoapFault faultstring.
	inst detail: aSoapFault detail.
	^inst ! !


!SoapError class methodsFor: 'defaults' stamp: 'MU 5/3/2002 02:03'!
client
	^self faultcode: #Client! !

!SoapError class methodsFor: 'defaults' stamp: 'MU 5/3/2002 02:03'!
mustUnderstand
	^self faultcode: #MustUnderstand! !

!SoapError class methodsFor: 'defaults' stamp: 'MU 5/3/2002 02:03'!
server
	^self faultcode: #Server! !

!SoapError class methodsFor: 'defaults' stamp: 'MU 5/3/2002 02:04'!
versionMismatch
	^self faultcode: #VersionMismatch! !


Object subclass: #SoapErrorLog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!
!SoapErrorLog commentStamp: '<historical>' prior: 0!
Write original error to a log file. 

---
mu 1/4/2002 22:51!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapErrorLog class
	instanceVariableNames: ''!

!SoapErrorLog class methodsFor: 'actions' stamp: 'MU 10/25/2002 02:00'!
write: anError 
	| ex file stack |
	ex := anError.
	file := FileStream fileNamed: 'soapError.log'.
	file isNil ifTrue: [Transcript cr; show: 'File open failed in SoapErrorLog'. ^self].
	file setToEnd.
	file cr; nextPutAll: '### Original Error is... ###'.
	file cr; nextPutAll: TimeStamp current printString.
	file cr; nextPutAll: '#Receiver: ' , ex receiver printString.
	file cr; nextPutAll: '#Description: ' , ex description.
	stack := SoPortableUtil stackTraceFrom: ex.
	file cr; nextPutAll: '#Stack:'.
	file cr; cr; nextPutAll: stack.
	file close! !


Object subclass: #SoapFaultDetailBuilder
	instanceVariableNames: ''
	classVariableNames: 'DefaultNamespace DefaultPrefix '
	poolDictionaries: ''
	category: 'SOAP-Base'!

!SoapFaultDetailBuilder methodsFor: 'actions' stamp: 'mu 2/8/2002 23:01'!
buildSoapFaultDetailOn: aSoapFault from: anError 
	| errorPrefix details stErrorClass isResumable messageText stack detail |
	aSoapFault faultstring: anError description.
	errorPrefix := self class defaultPrefix.
	details := SoapWrapElement named: 'details' withPrefix: errorPrefix.
	details declareNamespace: errorPrefix uri: self class defaultNamespace.
	stErrorClass := details createChildNamed: 'ErrorClass'.
	stErrorClass value: anError class name.
	isResumable := details createChildNamed: 'isResumable'.
	isResumable value: anError isResumable printString.
	anError messageText isNil
		ifFalse: [messageText := details createChildNamed: 'messageText'.
			messageText value: anError messageText].
	stack := details createChildNamed: 'stack'.
	stack value: (SoPortableUtil stackTraceFrom: anError).
	detail := aSoapFault addDetail.
	detail addSubElement: details.
	^ detail! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapFaultDetailBuilder class
	instanceVariableNames: ''!

!SoapFaultDetailBuilder class methodsFor: 'class initialization' stamp: 'mu 11/3/2001 19:22'!
initialize
	"SoapFaultDetailBuilder initialize"
	DefaultPrefix := DefaultNamespace := nil! !


!SoapFaultDetailBuilder class methodsFor: 'accessing' stamp: 'mu 11/3/2001 19:30'!
defaultNamespace
	DefaultNamespace isNil
		ifTrue: [DefaultNamespace := 'http://www.mars.dti.ne.jp/~umejava/smalltalk/soapOpera/error/'].
	^ DefaultNamespace! !

!SoapFaultDetailBuilder class methodsFor: 'accessing' stamp: 'mu 11/3/2001 19:26'!
defaultNamespace: aString
	DefaultNamespace := aString! !

!SoapFaultDetailBuilder class methodsFor: 'accessing' stamp: 'mu 11/3/2001 19:26'!
defaultPrefix
	DefaultPrefix isNil
		ifTrue: [DefaultPrefix := 'e'].
	^ DefaultPrefix
! !

!SoapFaultDetailBuilder class methodsFor: 'accessing' stamp: 'mu 11/3/2001 19:26'!
defaultPrefix: aString
	DefaultPrefix := aString! !


Error subclass: #SoapImplError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!
!SoapImplError commentStamp: '<historical>' prior: 0!
Abstract class for Soap implementation error.

---
mu 5/21/2001 22:30!


!SoapImplError methodsFor: 'exceptionDescription' stamp: 'mu 11/10/2001 18:50'!
isResumable
	
	^ true! !


SoapImplError subclass: #SoapInvalidParamName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!


SoapImplError subclass: #SoapNoNamespacePrefix
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!


SoapImplError subclass: #SoapNoSuchClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!


SoapNoSuchClass subclass: #SoapNoSuchExceptionClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!


SoapImplError subclass: #SoapNoSuchService
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!


SoapNoSuchClass subclass: #SoapNoSuchTransport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!


SoapImplError subclass: #SoapNoSuchType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!


SoapImplError subclass: #SoapServiceInvocationFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!


Object subclass: #SoapSetting
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!
!SoapSetting commentStamp: 'MU 10/5/2002 01:31' prior: 0!
Facade for setting SOAP related parameters

---
mu 1/4/2002 22:51!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapSetting class
	instanceVariableNames: 'defaultTransport '!

!SoapSetting class methodsFor: 'class initialization' stamp: 'MU 9/28/2002 23:08'!
initialize
	"SoapSetting initialize"
	defaultTransport := #http! !


!SoapSetting class methodsFor: 'encoding setting' stamp: 'mu 6/28/2001 00:57'!
useSchemaDatatypes1999
	SoXmlConstants xsiURI: 'http://www.w3.org/1999/XMLSchema'.
	SoXmlConstants xsiURI: 'http://www.w3.org/1999/XMLSchema-instance'.
	
	! !

!SoapSetting class methodsFor: 'encoding setting' stamp: 'mu 6/28/2001 00:57'!
useSchemaDatatypes2001
	SoXmlConstants xsiURI: 'http://www.w3.org/2001/XMLSchema'.
	SoXmlConstants xsiURI: 'http://www.w3.org/2001/XMLSchema-instance'.
	
	! !


!SoapSetting class methodsFor: 'log setting' stamp: 'mu 1/5/2002 00:40'!
showClientLog: aBoolean
	"SoapSetting showClientLog: true"
	"SoapSetting showClientLog: false"
	SoapAbstractConnector showLog: aBoolean.
	! !

!SoapSetting class methodsFor: 'log setting' stamp: 'MU 8/18/2002 17:31'!
showClientLogHttpLevel: aBoolean
	"SoapSetting showClientLogHttpLevel: true"
	"SoapSetting showClientLogHttpLevel: false"
	SoapHttpClient showLog: aBoolean.
	! !

!SoapSetting class methodsFor: 'log setting' stamp: 'MU 10/5/2002 23:31'!
showServerLog: aBoolean 
	"SoapSetting showServerLog: true"
	"SoapSetting showServerLog: false"
	Smalltalk at: #SoapHttpModule ifPresent: [:cls | cls showLog: aBoolean].
	Smalltalk at: #SoapSqtpHandler ifPresent: [:cls | cls showLog: aBoolean].
	! !

!SoapSetting class methodsFor: 'log setting' stamp: 'MU 10/5/2002 23:29'!
showingClientLog
	"SoapSetting showingClientLog"
	^SoapAbstractConnector showLog! !

!SoapSetting class methodsFor: 'log setting' stamp: 'MU 10/5/2002 23:29'!
showingClientLogHttpLevel
	"SoapSetting showingClientLogHttpLevel"
	^SoapHttpClient showLog
	! !

!SoapSetting class methodsFor: 'log setting' stamp: 'mu 3/9/2003 00:26'!
showingServerLog
	"SoapSetting showingServerLog"
	| results |
	results := OrderedCollection new.
	results add: (Smalltalk at: #SoapHttpService ifPresent: [:cls | cls showLog]). 
	results add: (Smalltalk at: #SoapSqtpHandler ifPresent: [:cls | cls showLog]).
	^results includesAnyOf: (Array with: true with: nil)
	

! !


!SoapSetting class methodsFor: 'transport setting' stamp: 'mu 10/9/2002 16:48'!
connectionTimeout
	^SoapAbstractSocketClient connectionTimeout! !

!SoapSetting class methodsFor: 'transport setting' stamp: 'mu 10/9/2002 16:48'!
connectionTimeout: timeout
	"SoapSetting connectionTimeout: 20"
	SoapAbstractSocketClient connectionTimeout: timeout! !

!SoapSetting class methodsFor: 'transport setting' stamp: 'mu 8/28/2002 16:50'!
defaultTransport
	defaultTransport isNil ifTrue: [defaultTransport _ #http].
	^defaultTransport! !

!SoapSetting class methodsFor: 'transport setting' stamp: 'mu 8/28/2002 16:48'!
defaultTransport: aSymbol 
	defaultTransport _ aSymbol! !

!SoapSetting class methodsFor: 'transport setting' stamp: 'mu 9/19/2002 18:43'!
resolveTimeout
	^SoapAbstractSocketClient resolveTimeout! !

!SoapSetting class methodsFor: 'transport setting' stamp: 'mu 9/19/2002 18:46'!
resolveTimeout: timeout
	"SoapSetting resolveTimeout: 20"
	SoapAbstractSocketClient resolveTimeout: timeout! !

!SoapSetting class methodsFor: 'transport setting' stamp: 'mu 9/18/2002 17:21'!
useHostAddressCache
	^SoapAbstractSocketClient useHostAddressCache! !

!SoapSetting class methodsFor: 'transport setting' stamp: 'mu 9/18/2002 17:21'!
useHostAddressCache: aBoolean
	"SoapSetting useHostAddressCache: true"
	"SoapSetting useHostAddressCache: false"
	SoapAbstractSocketClient useHostAddressCache: aBoolean
	! !


!SoapSetting class methodsFor: 'server setting' stamp: 'MU 4/18/2003 17:19'!
defaultPort
	"SoapSetting defaultPort"
	^SoapServerSetup defaultPortAt: (self defaultTransport)! !

!SoapSetting class methodsFor: 'server setting' stamp: 'MU 4/18/2003 17:19'!
defaultPort: anInteger 
	SoapServerSetup defaultPortAt: self defaultTransport put: anInteger.
	"Should I restart here?"
	self restart! !

!SoapSetting class methodsFor: 'server setting' stamp: 'MU 4/18/2003 17:19'!
defaultPortAt: tranportName
	"SoapSetting defaultPortAt: #http"
	^SoapServerSetup defaultPortAt: tranportName! !

!SoapSetting class methodsFor: 'server setting' stamp: 'MU 4/18/2003 17:19'!
defaultPortAt: tranportName put: portNumber
	"SoapSetting defaultPortAt: #http put: 8824"
	^SoapServerSetup defaultPortAt: tranportName put: portNumber! !

!SoapSetting class methodsFor: 'server setting' stamp: 'MU 4/18/2003 17:19'!
restart
	SoapServerSetup startAll! !


!SoapSetting class methodsFor: 'client setting' stamp: 'MU 9/28/2002 18:23'!
defaultSendingPort
	"SoapSetting defaultSendingPort"
	^SoapCallEntry defaultSendingPort! !

!SoapSetting class methodsFor: 'client setting' stamp: 'MU 9/28/2002 18:23'!
defaultSendingPort: portNumber
	"SoapSetting defaultSendingPort: 8823"
	^SoapCallEntry defaultSendingPort: portNumber! !


Warning subclass: #SoapTimeoutError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!

!SoapTimeoutError methodsFor: 'exceptionDescription' stamp: 'MU 9/25/2002 19:25'!
defaultAction
	Transcript show: self class name, ': data was late'; cr.
	self resume! !


SoXmlWrapElement subclass: #SoapWrapElement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!
!SoapWrapElement commentStamp: '<historical>' prior: 0!
Convenient XML Element which is contained in SoapElement

---
mu 1/4/2002 22:54!


!SoapWrapElement methodsFor: 'accessing' stamp: 'mu 5/6/2001 01:45'!
attributesHolder
	attributesHolder isNil ifTrue:[ attributesHolder := SoapAttributesHolder new].
	^attributesHolder! !


!SoapWrapElement methodsFor: 'actions' stamp: 'MU 4/27/2002 02:26'!
arrayItemType
	| arrType |
	arrType := self arrayType.
	^arrType isNil
		ifTrue: [(SoapConstants xsdAnyType)]
		ifFalse: [| end | 
			end := arrType findString: '[' startingAt: 0.
			(arrType copyFrom: 1 to: end - 1) ]! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 3/31/2002 20:50'!
arrayType
	^self getAttributeLike: self class arrayTypeMatchString.
	! !

!SoapWrapElement methodsFor: 'actions' stamp: 'mu 7/30/2001 00:45'!
declareEncodingIn: nameSpacePrefix  uri: uriString
	self putAttributeNamed: nameSpacePrefix, ':', SoapConstants encodingStyle value: uriString.! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 3/9/2002 01:42'!
declareSoapEncNamespace
	self declareNamespace: SoapConstants soapEncPrefix  uri: SoapConstants soapEncURI.
	! !

!SoapWrapElement methodsFor: 'actions' stamp: 'mu 7/30/2001 00:46'!
declareTypicalEncoding
	self declareEncodingIn: SoapConstants soapEnvPrefix uri: SoapConstants soapEncURI.! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 3/9/2002 01:43'!
declareTypicalNamespaces
	self declareSoapEncNamespace.
	self declareXsdNamespace.
	self declareXsiNamespace! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 3/9/2002 01:41'!
declareXsdNamespace
	self declareNamespace: SoapConstants xsdPrefix  uri: SoapConstants xsdURI.
	! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 3/9/2002 01:41'!
declareXsiNamespace
	self declareNamespace: SoapConstants xsiPrefix  uri: SoapConstants xsiURI.
	! !

!SoapWrapElement methodsFor: 'actions' stamp: 'mu 5/6/2001 02:19'!
encodingStyleURIs
	"ToDo: take a more serious approach...Namespace conscious"
	| encs |
	encs := self attributesHolder encodingStyle.
	((encs isNil	or: [encs isEmpty]) and: [self parent notNil])
		ifTrue: [^ self parent encodingStyleURIs].
	^ SoPortableUtil substringsFrom: encs! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 1/8/2003 01:50'!
href
	^self getAttributeNamed: SoapConstants href! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 1/8/2003 01:50'!
href: aString
	^self putAttributeNamed: SoapConstants href value: aString! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 1/8/2003 01:50'!
id
	^self getAttributeNamed: SoapConstants id! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 1/8/2003 01:50'!
id: aString
	^self putAttributeNamed: SoapConstants id value: aString! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 3/24/2002 02:27'!
size
	| arrType |
	arrType := self arrayType.
	^arrType isNil
		ifTrue: [self children size]
		ifFalse: [| start | 
			start := arrType findString: '[' startingAt: 0.
			(arrType copyFrom: start + 1 to: arrType size - 1) asNumber]! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 3/24/2002 00:04'!
xsiType
	^self getAttributeNamed: SoapConstants xsiType! !

!SoapWrapElement methodsFor: 'actions' stamp: 'MU 3/25/2002 00:12'!
xsiType: aString
	^self putAttributeNamed: SoapConstants xsiType value: aString! !


!SoapWrapElement methodsFor: 'testing' stamp: 'MU 3/31/2002 20:13'!
isArrayType
	^self hasAttributeLike: self class arrayTypeMatchString! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapWrapElement class
	instanceVariableNames: ''!

!SoapWrapElement class methodsFor: 'constants' stamp: 'MU 4/27/2002 02:28'!
arrayTypeMatchString
	^'*arrayType'.
	! !


SoapImplError subclass: #SoapWrongTagName
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Base'!

SoapConfigurationMap initialize!
SoapFaultDetailBuilder initialize!
SoapSetting initialize!