Object subclass: #SoapSixxDataBindingInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding-SIXX'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapSixxDataBindingInstaller class
	instanceVariableNames: ''!

!SoapSixxDataBindingInstaller class methodsFor: 'class initialization' stamp: 'MU 3/16/2002 18:56'!
initialize
	"SoapSixxDataBindingInstaller initialize"
	self install! !

!SoapSixxDataBindingInstaller class methodsFor: 'class initialization' stamp: 'MU 3/16/2002 18:54'!
obsolete
	self uninstall! !


!SoapSixxDataBindingInstaller class methodsFor: 'actions' stamp: 'MU 4/2/2002 00:37'!
install
	SoapEncoderFactory dataBindingDict at: SoapConstants soapSixxEncURI put: SoapSixxEncoder.
	SoapDecoderFactory dataBindingDict at: SoapConstants soapSixxEncURI put: SoapSixxDecoder.
	SoapEncodingStyleURIMap ariasURIDict at: #soapSixxEncoding put: SoapConstants soapSixxEncURI.! !

!SoapSixxDataBindingInstaller class methodsFor: 'actions' stamp: 'MU 6/29/2002 15:10'!
uninstall
	SoapEncoderFactory dataBindingDict removeKey: SoapConstants soapSixxEncURI.
	SoapDecoderFactory dataBindingDict removeKey: SoapConstants soapSixxEncURI.
	SoapEncodingStyleURIMap ariasURIDict removeKey: #soapSixxEncoding ! !


SoapAbstractDecoder subclass: #SoapSixxDecoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding-SIXX'!

!SoapSixxDecoder methodsFor: 'actions' stamp: 'MU 8/1/2002 01:21'!
decodeXmlElement: aSoapWrapElement
	^self decodeObjectXmlElement: aSoapWrapElement! !


!SoapSixxDecoder methodsFor: 'private' stamp: 'MU 8/1/2002 01:24'!
decodeObjectXmlElement: aSoapWrapElement
	^Object readSixxFrom: aSoapWrapElement children first xmlString! !


SoapAbstractEncoder subclass: #SoapSixxEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding-SIXX'!

!SoapSixxEncoder methodsFor: 'actions' stamp: 'MU 3/12/2002 02:23'!
encodeSoapVariable: aSoapVariable
	^self encodeObjectSoapVariable: aSoapVariable.
	! !


!SoapSixxEncoder methodsFor: 'private' stamp: 'MU 8/1/2002 01:14'!
encodeObjectSoapVariable: aSoapVariable
	| val  xmlStr sixxElem elem |
	val := aSoapVariable value.
	xmlStr := self xmlStringFromObject: val.
	sixxElem := self xmlElementClass fromXml: xmlStr.
	elem := self xmlElementClass named: aSoapVariable name.
	elem addChild: sixxElem.
	^elem! !

!SoapSixxEncoder methodsFor: 'private' stamp: 'MU 6/29/2002 15:27'!
xmlStringFromObject: anObject
	| str |
	str := anObject sixxString.  
	^str
	! !

SoapSixxDataBindingInstaller initialize!