Object subclass: #SoapSrpDataBindingInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding-SRP'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapSrpDataBindingInstaller class
	instanceVariableNames: ''!

!SoapSrpDataBindingInstaller class methodsFor: 'class initialization' stamp: 'MU 3/16/2002 18:56'!
initialize
	"SoapSrpDataBindingInstaller initialize"
	self install! !

!SoapSrpDataBindingInstaller class methodsFor: 'class initialization' stamp: 'MU 3/16/2002 18:54'!
obsolete
	self uninstall! !


!SoapSrpDataBindingInstaller class methodsFor: 'actions' stamp: 'MU 4/2/2002 00:37'!
install
	SoapEncoderFactory dataBindingDict at: SoapConstants soapSrpEncURI put: SoapSrpEncoder.
	SoapDecoderFactory dataBindingDict at: SoapConstants soapSrpEncURI put: SoapSrpDecoder.
	SoapEncodingStyleURIMap ariasURIDict at: #soapSrpEncoding put: SoapConstants soapSrpEncURI.! !

!SoapSrpDataBindingInstaller class methodsFor: 'actions' stamp: 'MU 6/29/2002 15:10'!
uninstall
	SoapEncoderFactory dataBindingDict removeKey: SoapConstants soapSrpEncURI.
	SoapDecoderFactory dataBindingDict removeKey: SoapConstants soapSrpEncURI.
	SoapEncodingStyleURIMap ariasURIDict removeKey: #soapSrpEncoding ! !


SoapAbstractDecoder subclass: #SoapSrpDecoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding-SRP'!

!SoapSrpDecoder methodsFor: 'actions' stamp: 'MU 3/12/2002 02:27'!
decodeXmlElement: aSoapWrapElement
	^self decodeObjectXmlElement: aSoapWrapElement! !


!SoapSrpDecoder methodsFor: 'private' stamp: 'MU 3/12/2002 02:25'!
decodeObjectXmlElement: aSoapWrapElement
	^self objectFromString: aSoapWrapElement value.
	! !

!SoapSrpDecoder methodsFor: 'private' stamp: 'MU 3/12/2002 02:26'!
objectFromString: aString
	| obj |
	obj := SrpObjectStream loadObjectFromText: aString. 
	^obj! !


SoapAbstractEncoder subclass: #SoapSrpEncoder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding-SRP'!

!SoapSrpEncoder methodsFor: 'actions' stamp: 'MU 3/12/2002 02:23'!
encodeSoapVariable: aSoapVariable
	^self encodeObjectSoapVariable: aSoapVariable.
	! !


!SoapSrpEncoder methodsFor: 'private' stamp: 'MU 3/12/2002 02:39'!
encodeObjectSoapVariable: aSoapVariable
	| val  valStr elem |
	val := aSoapVariable value.
	valStr := self stringFromObject: val.
	elem := self xmlElementClass named: aSoapVariable name.
	elem putAttributeNamed: (SoapConstants xsiType) value: 'SRP:Object'.
	elem value: valStr.
	^elem! !

!SoapSrpEncoder methodsFor: 'private' stamp: 'MU 3/12/2002 02:22'!
stringFromObject: anObject
	| str |
	str := SrpObjectStream saveObjectAsText: anObject.  
	^str
	! !

SoapSrpDataBindingInstaller initialize!