Object subclass: #SoapDataBinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding'!

!SoapDataBinder methodsFor: 'accessing' stamp: 'mu 8/26/2001 01:16'!
typeDict
	^self class typeDict! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapDataBinder class
	instanceVariableNames: 'typeDict '!

!SoapDataBinder class methodsFor: 'class initialization' stamp: 'mu 8/26/2001 01:07'!
initTypeDict

	^typeDict := IdentityDictionary new.
	! !

!SoapDataBinder class methodsFor: 'class initialization' stamp: 'mu 8/26/2001 01:08'!
initialize
	self initTypeDict! !


!SoapDataBinder class methodsFor: 'accessing' stamp: 'mu 12/13/2001 00:41'!
typeDict
	typeDict isNil ifTrue: [self initTypeDict].
	^typeDict! !


Object subclass: #SoapDataBindingFactory
	instanceVariableNames: ''
	classVariableNames: 'DataBindingDict '
	poolDictionaries: ''
	category: 'SOAP-DataBinding'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapDataBindingFactory class
	instanceVariableNames: 'dataBindingDict '!

!SoapDataBindingFactory class methodsFor: 'class initialization' stamp: 'mu 8/26/2001 00:41'!
initialize
	"SoapDataBindingFactory initialize"
	dataBindingDict := nil! !

!SoapDataBindingFactory class methodsFor: 'class initialization' stamp: 'MU 3/16/2002 18:37'!
initializeAll
	"SoapDataBindingFactory initializeAll"
	self allSubclassesDo:[:each | each initialize]! !


!SoapDataBindingFactory class methodsFor: 'actions' stamp: 'mu 12/21/2001 01:04'!
createFrom: anArrayOfEncodingStyleURI 
	| uriArr key |
	anArrayOfEncodingStyleURI size > 1
		ifTrue: [self noSuchDataBinder signal: 'Currently multi encodingStyleURI is not supported'].
	uriArr := (anArrayOfEncodingStyleURI isNil
					or: [anArrayOfEncodingStyleURI isEmpty])
				ifTrue: [self defaultEncodingStyleURIs.]
				ifFalse: [anArrayOfEncodingStyleURI].
	key := uriArr first.	"##TODO: to support multi encoders"
	^ (self dataBindingDict
		at: key
		ifAbsent: [self noSuchDataBinder signal: key]) new! !


!SoapDataBindingFactory class methodsFor: 'default values' stamp: 'mu 10/6/2001 20:25'!
defaultEncodingStyleURIs
	^Array with: SoapConstants soapEncURI! !

!SoapDataBindingFactory class methodsFor: 'default values' stamp: 'mu 8/26/2001 00:44'!
initDataBindingDict
	"Default do nothing"
	! !


!SoapDataBindingFactory class methodsFor: 'accessing' stamp: 'mu 8/26/2001 00:41'!
dataBindingDict
	dataBindingDict isNil
		ifTrue: [dataBindingDict := Dictionary new.
			self initDataBindingDict].
	^ dataBindingDict! !

!SoapDataBindingFactory class methodsFor: 'accessing' stamp: 'mu 8/20/2001 01:33'!
uriEncoderDict
	^UriEncoderDict! !


!SoapDataBindingFactory class methodsFor: 'accessing-error' stamp: 'mu 10/6/2001 20:38'!
noSuchDataBinder
	^SoapNoSuchDataBinder
	! !


SoapImplError subclass: #SoapDatabindingError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding'!


Object subclass: #SoapEncodingStyleURIMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapEncodingStyleURIMap class
	instanceVariableNames: 'ariasURIDict '!

!SoapEncodingStyleURIMap class methodsFor: 'class initialization' stamp: 'mu 6/6/2001 00:40'!
initialize
	"SoapEncodingStyleURIMap initialize"
	ariasURIDict := IdentityDictionary new.
	self initAriasURIDict.
	! !


!SoapEncodingStyleURIMap class methodsFor: 'default values' stamp: 'MU 10/14/2002 23:59'!
initAriasURIDict
	self ariasURIDict at: #nullEncoding put: SoapConstants nullEncURI.
	self ariasURIDict at: #soapEncoding put: SoapConstants soapEncURI.
	self ariasURIDict at: #soapSqEncoding put: SoapConstants soapSqEncURI.! !


!SoapEncodingStyleURIMap class methodsFor: 'actions' stamp: 'mu 6/6/2001 00:40'!
at: anAriasSymbol
	^self ariasURIDict at: anAriasSymbol ifAbsent:[SoapNoSuchEncodingArias signal: anAriasSymbol].! !


!SoapEncodingStyleURIMap class methodsFor: 'accessing' stamp: 'mu 6/6/2001 00:39'!
ariasURIDict
	^ariasURIDict! !


SoapImplError subclass: #SoapNoSuchDataBinder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding'!


SoapImplError subclass: #SoapNoSuchEncodingArias
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-DataBinding'!

SoapDataBinder initialize!
SoapDataBindingFactory initialize!
SoapEncodingStyleURIMap initialize!