Object subclass: #SoapExampleClient
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Example'!
!SoapExampleClient commentStamp: '<historical>' prior: 0!
Simple SOAP client example.

- Call services implemented in SoapExampleServiceImpl

---
mu 1/4/2002 23:05!


!SoapExampleClient methodsFor: 'actions' stamp: 'mu 5/5/2003 17:06'!
callBrowseClassDefinition: aString 
	| call |
	call := (SoapCallEntry tcpHost: self hostAddress port: self port) newCall.
	call transport: self transport.
	call targetObjectURI: self targetObjectURI.
	call methodName: 'browseClassDefinition'.
	call
		addParameter: (SoapVariable name: #className value: aString).
	^call invokeAndReturn asString! !

!SoapExampleClient methodsFor: 'actions' stamp: 'mu 5/4/2003 19:51'!
callHelloWorld	
	| call |
	call := (SoapCallEntry tcpHost: self hostAddress port: self port) newCall.
	call transport: self transport.
	call targetObjectURI: self targetObjectURI.
	call methodName: 'helloWorld'.
	
	^call invokeAndReturn! !

!SoapExampleClient methodsFor: 'actions' stamp: 'mu 5/4/2003 19:51'!
callReturnComplexDictionary
	| call dict |
	call := (SoapCallEntry tcpHost: self hostAddress port: self port) newCall.
	call transport: self transport.
	call targetObjectURI: self targetObjectURI.
	call methodName: 'returnComplexDictionary'.
	dict := Dictionary new.
	dict at: #Java put: 'Forget it'.
	call addParameter: (SoapVariable name: #aDictionary value: dict).
	
	^call invokeAndReturn! !

!SoapExampleClient methodsFor: 'actions' stamp: 'mu 5/4/2003 19:51'!
callReverseArray: arrayOfSimpleType
	| call |
	call := (SoapCallEntry tcpHost: self hostAddress port: self port) newCall.
	call transport: self transport.
	call targetObjectURI: self targetObjectURI.
	call methodName: 'reverseArray'.
	call addParameter: (SoapVariable name: #anArray value: arrayOfSimpleType).
	
	^call invokeAndReturn! !

!SoapExampleClient methodsFor: 'actions' stamp: 'mu 5/4/2003 19:51'!
callReverseString: aString
	| call |
	call := (SoapCallEntry tcpHost: self hostAddress port: self port) newCall.
	call transport: self transport.
	call targetObjectURI: self targetObjectURI.
	call methodName: 'reverseString'.
	call addParameter: (SoapVariable name: #aString value: aString).
	
	^call invokeAndReturn! !

!SoapExampleClient methodsFor: 'actions' stamp: 'mu 5/4/2003 19:51'!
callTimeNow
	| call |
	call := (SoapCallEntry tcpHost: self hostAddress port: self port) newCall.
	call transport: self transport.
	call targetObjectURI: self targetObjectURI.
	call methodName: 'timeNow'.
	
	^call invokeAndReturn! !

!SoapExampleClient methodsFor: 'actions' stamp: 'mu 5/4/2003 19:51'!
callTranscriptShow: aString
	| call |
	call := (SoapCallEntry tcpHost: self hostAddress port: self port) newCall.
	call transport: self transport.
	call targetObjectURI: self targetObjectURI.
	call methodName: 'transcriptShow'.
	call addParameter: (SoapVariable name: #aString value: aString).
	
	^call invokeAndReturn! !


!SoapExampleClient methodsFor: 'accessing' stamp: 'mu 2/8/2002 22:39'!
hostAddress
	^self class hostAddress! !

!SoapExampleClient methodsFor: 'accessing' stamp: 'mu 2/8/2002 22:48'!
port
	^self class port! !

!SoapExampleClient methodsFor: 'accessing' stamp: 'mu 2/8/2002 22:41'!
targetObjectURI
	^self class targetObjectURI! !

!SoapExampleClient methodsFor: 'accessing' stamp: 'MU 10/6/2002 00:21'!
transport
	^self class transport! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapExampleClient class
	instanceVariableNames: 'hostAddress port transport targetObjectURI '!

!SoapExampleClient class methodsFor: 'class initialization' stamp: 'MU 10/6/2002 00:22'!
initialize
	"SoapExampleClient initialize" 
	hostAddress := 'localhost'.
	port := SoapSetting defaultSendingPort.
	transport := #http.
	targetObjectURI := ''! !


!SoapExampleClient class methodsFor: 'accessing' stamp: 'mu 1/4/2002 23:54'!
hostAddress
	^hostAddress! !

!SoapExampleClient class methodsFor: 'accessing' stamp: 'mu 1/4/2002 23:54'!
hostAddress: aString
	hostAddress := aString! !

!SoapExampleClient class methodsFor: 'accessing' stamp: 'mu 2/8/2002 22:49'!
port
	^port! !

!SoapExampleClient class methodsFor: 'accessing' stamp: 'mu 2/8/2002 22:49'!
port: anInteger
	port := anInteger! !

!SoapExampleClient class methodsFor: 'accessing' stamp: 'mu 2/8/2002 22:37'!
targetObjectURI
	^targetObjectURI! !

!SoapExampleClient class methodsFor: 'accessing' stamp: 'mu 2/8/2002 22:37'!
targetObjectURI: aString
	targetObjectURI := aString! !

!SoapExampleClient class methodsFor: 'accessing' stamp: 'MU 10/6/2002 00:22'!
transport
	^transport! !

!SoapExampleClient class methodsFor: 'accessing' stamp: 'MU 10/6/2002 00:30'!
transport: aSymbol
	"SoapExampleClient transport: #sqtp"
	"#http or #sqtp"
	transport := aSymbol! !


Object subclass: #SoapExampleDoc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Example'!
!SoapExampleDoc commentStamp: '<historical>' prior: 0!
-SoapCore example documentation- See class side

---
MU 5/2/2002 01:15!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapExampleDoc class
	instanceVariableNames: ''!

!SoapExampleDoc class methodsFor: 'documentation' stamp: 'MU 10/6/2002 00:32'!
howToRunExample
^'1:
	Register services.
	"SoapExampleServiceImpl registerAllServices"

2:
	Call services by SoapExampleClient (print it)
	"SoapExampleClient new callHelloWorld"
	"SoapExampleClient new callTimeNow"
	"SoapExampleClient new callReverseString: self name printString"
	"SoapExampleClient new callTranscriptShow: self name printString"
	"SoapExampleClient new callBrowseClassDefinition: #Array"
	"SoapExampleClient new callReverseArray: #(1 #two 3.0)"
	"SoapExampleClient new callReturnComplexDictionary"

	(If you register services in some remote machine, you have to set class inst var "hostAddress".)
	"SoapExampleClient hostAddress: #yourServerName"

	(If you register services in a different port number other than default 8823)
	Server Side: "SoapSetting defaultPort: 1212"
	Client Side: "SoapSetting defaultSendingPort: 1212" or "SoapExampleClient port: 1212"(Example only)

3:
	If you would like to see raw XMLs, do it. (Open Transcript.)
	"SoapSetting showClientLog: true" 
	"SoapSetting showServerLog: true" 
	
	If you would like to see raw HTML headers for debugging, do it. (Open Transcript.)
	"SoapSetting showClientLogHttpLevel: true"

4:
	Multiple transport protocols are supported in SoapCore. Default is well known HTTP. 
	But you can try another protocol, SQTP (Squeak Transport Protocol).
	SQTP is fast in sending bulky data (more than approximately 700 bytes).
	
	First check your server is running what transport protocols.
	"SoapExampleServiceImpl runningTransportDescriptions"

	Change the default transport protocol in the client side.
	"SoapExampleClient transport: #sqtp"	
	
	Call the services, especially #reverseString: ; you can see the difference.

---
MU 10/6/2002 00:24
'! !


Object subclass: #SoapExampleServiceImpl
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Example'!
!SoapExampleServiceImpl commentStamp: '<historical>' prior: 0!
Simple SOAP server example.

- Implements very trivial services. (like just returning 'HelloWorld')

- To register services, see class side.

---
mu 1/4/2002 23:05!


!SoapExampleServiceImpl methodsFor: 'actions' stamp: 'mu 2/6/2002 02:02'!
browseClassDefinition: aClassName
	
	| stream targetClass |
	stream := WriteStream on: (String new: 1024).
	targetClass := self class environment at: aClassName asSymbol.
	targetClass fileOutOn: (stream).
	^stream contents asByteArray
	! !

!SoapExampleServiceImpl methodsFor: 'actions' stamp: 'mu 1/4/2002 22:59'!
helloWorld
	^'HelloWorld' ! !

!SoapExampleServiceImpl methodsFor: 'actions' stamp: 'MU 10/15/2002 01:00'!
returnComplexDictionary: aDictionary
	| dictionary |
	dictionary := aDictionary.
	dictionary at: #Smalltlak put: 'Best'.
	dictionary at: #Ruby put: #('Beautiful' 'Need IDE').
	^dictionary! !

!SoapExampleServiceImpl methodsFor: 'actions' stamp: 'mu 8/30/2002 02:02'!
reverseArray: anArray
	Transcript cr; show: 'rev: ', Time now printString.
	^anArray reverse! !

!SoapExampleServiceImpl methodsFor: 'actions' stamp: 'mu 1/9/2002 23:17'!
reverseString: aString
	^aString reverse! !

!SoapExampleServiceImpl methodsFor: 'actions' stamp: 'mu 1/4/2002 22:59'!
timeNow
	^Time now printString! !

!SoapExampleServiceImpl methodsFor: 'actions' stamp: 'mu 1/5/2002 01:04'!
transcriptShow: aString 
	[Transcript cr; show: '#soap> ' , aString.
	^ true]
		on: Error
		do: [:ex | 
			Transcript cr; show: '#soap> ' , ex description.
			^ false]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapExampleServiceImpl class
	instanceVariableNames: ''!

!SoapExampleServiceImpl class methodsFor: 'server status' stamp: 'MU 4/18/2003 17:19'!
runningTransportDescriptions
	"SoapExampleServiceImpl runningTransportDescriptions"
	"Show what transport server(s) is running"
	^SoapServerSetup runningTransportDescriptions! !


!SoapExampleServiceImpl class methodsFor: 'registering' stamp: 'mu 1/4/2002 23:27'!
inspectRegisteredServices
	"SoapExampleServiceImpl inspectRegisteredServices"
	SoapServiceHandler default serviceHome inspect! !

!SoapExampleServiceImpl class methodsFor: 'registering' stamp: 'MU 4/18/2003 17:20'!
registerAllServices
	"SoapExampleServiceImpl registerAllServices"
	SoapServerSetup startAll.
	self registerHelloWorld.
	self registerTimeNow.
	self registerReverseString.
	self registerTranscriptShow.
	self registerBrowseClassDefinition.
	self registerReverseArray.
	self registerReturnComplexDictionary! !


!SoapExampleServiceImpl class methodsFor: 'private' stamp: 'mu 2/6/2002 02:44'!
registerBrowseClassDefinition
	| impl serv |
	impl := self new.
	serv := SoapService implementor: impl selector: #browseClassDefinition:.
	serv signature: (SoapServiceSignature name: 'browseClassDefinition' paramNames: #(className)).
	SoapServiceHandler default add: serv! !

!SoapExampleServiceImpl class methodsFor: 'private' stamp: 'mu 1/4/2002 23:15'!
registerHelloWorld
	| impl serv |
	impl := self new.
	serv := SoapService implementor: impl selector: #helloWorld.
	serv signature: (SoapServiceSignature name: 'helloWorld').
	SoapServiceHandler default add: serv! !

!SoapExampleServiceImpl class methodsFor: 'private' stamp: 'mu 1/7/2002 00:15'!
registerReturnComplexDictionary
	| impl serv |
	impl := self new.
	serv := SoapService implementor: impl selector: #returnComplexDictionary:.
	serv signature: (SoapServiceSignature name: 'returnComplexDictionary' paramNames: #(aDictionary)).
	SoapServiceHandler default add: serv! !

!SoapExampleServiceImpl class methodsFor: 'private' stamp: 'MU 3/31/2002 19:07'!
registerReverseArray
	| impl serv |
	impl := self new.
	serv := SoapService implementor: impl selector: #reverseArray:.
	serv signature: (SoapServiceSignature name: 'reverseArray' paramNames: #(anArray)).
	SoapServiceHandler default add: serv! !

!SoapExampleServiceImpl class methodsFor: 'private' stamp: 'mu 1/4/2002 23:22'!
registerReverseString
	| impl serv |
	impl := self new.
	serv := SoapService implementor: impl selector: #reverseString:.
	serv signature: (SoapServiceSignature name: 'reverseString' paramNames: #(aString)).
	SoapServiceHandler default add: serv! !

!SoapExampleServiceImpl class methodsFor: 'private' stamp: 'mu 1/4/2002 23:16'!
registerTimeNow
	| impl serv |
	impl := self new.
	serv := SoapService implementor: impl selector: #timeNow.
	serv signature: (SoapServiceSignature name: 'timeNow').
	SoapServiceHandler default add: serv! !

!SoapExampleServiceImpl class methodsFor: 'private' stamp: 'mu 1/5/2002 01:03'!
registerTranscriptShow
	| impl serv |
	impl := self new.
	serv := SoapService implementor: impl selector: #transcriptShow:.
	serv signature: (SoapServiceSignature name: 'transcriptShow' paramNames: #(aString)).
	SoapServiceHandler default add: serv! !

SoapExampleClient initialize!