Object subclass: #SoapServerSetup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-ServerBase'!
!SoapServerSetup commentStamp: 'MU 10/5/2002 01:21' prior: 0!
I can set up transport protocols for SOAP.
I am used for server which runs SoapCore web services.

-SoapTransportSetup runningTransportDescriptions "Returns current running transports"
-SoapTransportSetup start: #(http) "start #http transport "

---
MU 10/5/2002 01:18!


"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapServerSetup class
	instanceVariableNames: 'defaultPort handler '!

!SoapServerSetup class methodsFor: 'class initialization' stamp: 'mu 5/1/2003 18:50'!
initialize
	"SoapServerSetup initialize"
	self name == #SoapServerSetup
		ifTrue: [Smalltalk addToStartUpList: self.
			Smalltalk addToShutDownList: self]
		ifFalse: [SoapServerSetupMap at: self transportName asSymbol put: self.
			self release]! !

!SoapServerSetup class methodsFor: 'class initialization' stamp: 'mu 5/1/2003 18:50'!
initializeAfterLoad

	self name == #SoapServerSetup
		ifFalse: [SoapServerSetupMap at: self transportName asSymbol put: self].
! !

!SoapServerSetup class methodsFor: 'class initialization' stamp: 'mu 5/1/2003 18:49'!
initializeAll
	"SoapServerSetup initializeAll"
	
	self subclassesDo: [:each | each initialize]! !

!SoapServerSetup class methodsFor: 'class initialization' stamp: 'mu 5/1/2003 18:51'!
obsolete
	self name == #SoapServerSetup
		ifTrue: [self stopAll.
			Smalltalk removeFromStartUpList: self.
			Smalltalk removeFromShutDownList: self]
		ifFalse: [SoapServerSetupMap removeAt: self transportName asSymbol].
	super obsolete! !

!SoapServerSetup class methodsFor: 'class initialization' stamp: 'mu 5/4/2003 18:52'!
release
	"SoapServerSetup release"
	self stop.
	defaultPort := handler := nil! !


!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/1/2003 18:31'!
defaultPortAt: transportName 
	"SoapServerSetup defaultPortAt: #http"
	| setUp |
	setUp := SoapServerSetupMap at: transportName.
	^ setUp defaultPort! !

!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/1/2003 18:44'!
defaultPortAt: transportName put: portNumber
	"SoapServerSetup defaultPortAt: #http put: 8824"
	| setUp |
	setUp := SoapServerSetupMap at: transportName.
	setUp isNil
		ifTrue: [SoapServerSetupMap initialize.
			setUp := SoapServerSetupMap at: #http].
	^ setUp defaultPort: portNumber! !

!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/1/2003 18:44'!
restartAt: transportName port: portNumber 
	"SoapServerSetup restartAt: #http port: 8824"
	| setUp |
	setUp := SoapServerSetupMap at: transportName.
	setUp isNil
		ifFalse: [setUp startOn: portNumber]! !

!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/1/2003 18:44'!
runningTransportDescriptions
	"SoapServerSetup runningTransportDescriptions"
	^ self subclasses
		select: [:each | each handler isRunning] thenCollect:[:each | (each transportName, ':', each handler port printString) asSymbol]! !

!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/1/2003 18:45'!
runningTransportNames
	"SoapServerSetup runningTransportNames"
	^ self subclasses
		select: [:each | each handler isRunning] thenCollect:[:each | each transportName]! !

!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/1/2003 18:45'!
start: transportNames 
	"SoapServerSetup start: #(http) "
	transportNames
		do: [:each | 
			| setUp | 
			setUp := SoapServerSetupMap at: each.
			setUp isNil
				ifFalse: [setUp stop; start]]! !

!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/4/2003 19:45'!
startAll
	"SoapServerSetup startAll"
	self name == #SoapServerSetup
		ifTrue: [self subclassesDo: [:each | each start]]! !

!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/1/2003 18:45'!
startOnly: transportNames 
	"SoapServerSetup startOnly: #(http) "
	| stops |
	stops := SoapServerSetupMap implDict keys removeAll: transportNames; yourself.
	self stop: stops.
	self start: transportNames! !

!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/1/2003 18:45'!
stop: transportNames 
	"SoapServerSetup stop: #(http)"
	transportNames
		do: [:each | 
			| setUp | 
			setUp := SoapServerSetupMap at: each.
			setUp isNil
				ifFalse: [setUp stop]]! !

!SoapServerSetup class methodsFor: 'utility' stamp: 'mu 5/4/2003 19:50'!
stopAll
	"SoapServerSetup stopAll"
	self name == #SoapServerSetup
		ifTrue: [self subclassesDo: [:each | each stop]]! !


!SoapServerSetup class methodsFor: 'actions' stamp: 'mu 8/28/2002 15:49'!
start
	self stop.
	^self handler start! !

!SoapServerSetup class methodsFor: 'actions' stamp: 'MU 9/28/2002 19:02'!
startOn: port
	self stop.
	self handler port: port.
	^self handler start! !

!SoapServerSetup class methodsFor: 'actions' stamp: 'mu 5/28/2003 12:03'!
stop
	handler isNil
		ifFalse: [self handler stop].
	handler := nil! !


!SoapServerSetup class methodsFor: 'defaults' stamp: 'MU 8/28/2002 14:43'!
defaultHandler
	self subclassResponsibility! !

!SoapServerSetup class methodsFor: 'defaults' stamp: 'MU 9/28/2002 18:44'!
defaultPort
	self subclassResponsibility.
	! !

!SoapServerSetup class methodsFor: 'defaults' stamp: 'MU 8/28/2002 14:42'!
defaultPort: anInteger
	defaultPort := anInteger.! !


!SoapServerSetup class methodsFor: 'accessing' stamp: 'MU 8/28/2002 14:43'!
handler
	handler isNil ifTrue: [ handler := self defaultHandler ].
	^handler! !


!SoapServerSetup class methodsFor: 'start up/shut down' stamp: 'MU 8/28/2002 18:41'!
shutDown
	self stopAll! !

!SoapServerSetup class methodsFor: 'start up/shut down' stamp: 'MU 8/28/2002 18:41'!
startUp
	self startAll! !


!SoapServerSetup class methodsFor: 'constants' stamp: 'mu 8/28/2002 16:19'!
transportName
	"self subclassResponsibility"
	^#noName! !


SoapConfigurationMap subclass: #SoapServerSetupMap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-ServerBase'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapServerSetupMap class
	instanceVariableNames: ''!

!SoapServerSetupMap class methodsFor: 'factory' stamp: 'mu 5/1/2003 18:02'!
rootImplClassName
	^#SoapServerSetup! !


!SoapServerSetupMap class methodsFor: 'actions' stamp: 'mu 5/1/2003 18:34'!
at: aSymbol 
	| cls |
	cls := super at: aSymbol.
	^ cls isNil
		ifTrue: [SoapNoSuchTransport signal: aSymbol printString]
		ifFalse: [cls]! !


Object subclass: #SoapService
	instanceVariableNames: 'signature selector implementor targetObjectURI '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-ServerBase'!
!SoapService commentStamp: 'MU 10/5/2002 01:28' prior: 0!
I represend a SOAP service.

For example, to create ordered collection' s add: service:

service := SoapService implementor: orderedCollection selector: #add:.
service signature: (SoapServiceSignature name: 'add' paramNames: #(newElem)).

---
MU 10/5/2002 01:25!


!SoapService methodsFor: 'actions' stamp: 'mu 9/24/2001 01:26'!
getSignatureNamed: aSignatureName 
	^ (self signature name = aSignatureName)
		ifTrue:[self signature]
		ifFalse: [SoapNoSuchService signal: aSignatureName]! !

!SoapService methodsFor: 'actions' stamp: 'MU 4/28/2002 01:39'!
invoke: aSoapSignature 
	| registeredSig values |
	registeredSig := self getSignatureNamed: aSoapSignature name.
	registeredSig verify: aSoapSignature.
	values := registeredSig paramNames
				collect: [:each | aSoapSignature valueAt: each ifAbsent:[nil]].
	^ self implementor perform: self selector withArguments: values! !

!SoapService methodsFor: 'actions' stamp: 'mu 9/24/2001 01:50'!
name
	"##currently just ignore namespace##"
	^self signature name! !

!SoapService methodsFor: 'actions' stamp: 'mu 1/4/2002 02:03'!
pathName
	"##currently just ignore namespace##"
	^ self targetObjectURI isEmpty
		ifTrue: [self name]
		ifFalse: [self targetObjectURI , ':' , self name]! !


!SoapService methodsFor: 'accessing' stamp: 'mu 9/5/2001 20:24'!
implementor

	^implementor! !

!SoapService methodsFor: 'accessing' stamp: 'mu 9/5/2001 20:24'!
implementor: aValue

	implementor := aValue! !

!SoapService methodsFor: 'accessing' stamp: 'mu 9/18/2001 20:43'!
selector

	^selector! !

!SoapService methodsFor: 'accessing' stamp: 'mu 9/18/2001 20:43'!
selector: aValue

	selector := aValue! !

!SoapService methodsFor: 'accessing' stamp: 'mu 9/18/2001 21:18'!
signature
	
	^signature! !

!SoapService methodsFor: 'accessing' stamp: 'mu 9/18/2001 18:03'!
signature: aValue

	signature := aValue! !

!SoapService methodsFor: 'accessing' stamp: 'mu 12/27/2001 23:22'!
targetObjectURI
	targetObjectURI isNil ifTrue: [targetObjectURI := ''].
	^targetObjectURI! !

!SoapService methodsFor: 'accessing' stamp: 'mu 12/28/2001 18:47'!
targetObjectURI: aString
	targetObjectURI := SoPortableUtil relativeURIFrom: aString.! !


!SoapService methodsFor: 'printing' stamp: 'mu 1/4/2002 23:35'!
printOn: aStream
	aStream nextPutAll: 'aSoapService{ '.
	self signature isNil ifFalse: [aStream nextPutAll: 'signature: ', self signature printString].
	self targetObjectURI isEmpty ifFalse: [aStream nextPutAll: ' targetObjectURI: ', self targetObjectURI printString].
	self implementor isNil ifFalse: [aStream nextPutAll: ' implementor: ', self implementor printString].
	self selector isNil ifFalse: [aStream nextPutAll: ' selector: ', self selector printString].
	aStream nextPutAll: '} '.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapService class
	instanceVariableNames: ''!

!SoapService class methodsFor: 'instance creation' stamp: 'mu 9/18/2001 21:20'!
implementor: anObject selector: aSymbol 
	^ self new 
		 implementor: anObject;
		 selector: aSymbol! !


Object subclass: #SoapServiceHandler
	instanceVariableNames: 'serviceHome envelope context responseEncoder faultDetailBuilder '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-ServerBase'!
!SoapServiceHandler commentStamp: 'MU 10/5/2002 01:24' prior: 0!
I manage SOAP services in server. 

-SoapServiceHandler default serviceHome inspect "You can see registerd SOAP services"

---
MU 10/5/2002 01:21!


!SoapServiceHandler methodsFor: 'initialize-release' stamp: 'mu 11/10/2001 20:07'!
initialize
	serviceHome := context := responseEncoder := faultDetailBuilder := nil! !


!SoapServiceHandler methodsFor: 'service register/unregister' stamp: 'mu 12/21/2001 00:57'!
add: aSoapService
	"shortcut for global service"
	^ self at: aSoapService pathName put: aSoapService ! !

!SoapServiceHandler methodsFor: 'service register/unregister' stamp: 'mu 12/21/2001 00:58'!
at: aServicePathname
	^ self serviceHome at: aServicePathname ! !

!SoapServiceHandler methodsFor: 'service register/unregister' stamp: 'mu 12/21/2001 00:57'!
at: aServicePathname put: aSoapService
	^ self serviceHome at: aServicePathname put: aSoapService ! !

!SoapServiceHandler methodsFor: 'service register/unregister' stamp: 'mu 12/21/2001 00:57'!
remove: aSoapService
	"shortcut for global service"
	^ self serviceHome removeKey: aSoapService pathName! !


!SoapServiceHandler methodsFor: 'actions' stamp: 'mu 1/27/2002 01:04'!
dispatch: aSoapEnvelope with: aSoapContext 
	| env |
	self envelope: aSoapEnvelope.
	self context: aSoapContext.
	env := [| ret | 
			ret := self invoke: aSoapEnvelope.
			self wrapResult: ret]
				on: Error
				do: [:ex | 
					SoapErrorLog write: ex.
					ex
						return: (self wrapError: ex)].
	^ env! !

!SoapServiceHandler methodsFor: 'actions' stamp: 'mu 1/7/2002 00:10'!
encoding: aSymbol
	| uris |
	uris := Array with: (SoapEncodingStyleURIMap at: aSymbol).
	^self responseEncoder: (SoapEncoderFactory createFrom: uris).  ! !


!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 10/13/2001 19:55'!
context
	^context! !

!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 10/13/2001 19:55'!
context: aValue

	context := aValue! !

!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 1/27/2002 01:00'!
envelope
	^envelope! !

!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 1/27/2002 01:00'!
envelope: aValue

	envelope := aValue! !

!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 11/3/2001 20:26'!
faultDetailBuilder
	faultDetailBuilder isNil ifTrue:[faultDetailBuilder := SoapFaultDetailBuilder new].
	^faultDetailBuilder! !

!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 11/3/2001 20:25'!
faultDetailBuilder: aValue

	faultDetailBuilder := aValue! !

!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 1/4/2002 23:10'!
responseEncoder
	responseEncoder isNil ifTrue:[responseEncoder := self class defaultResponseEncoder].
	^responseEncoder! !

!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 10/13/2001 20:29'!
responseEncoder: aValue

	responseEncoder := aValue! !

!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 9/5/2001 20:32'!
serviceHome
	serviceHome isNil ifTrue:[serviceHome := SoapServiceHome new].
	^serviceHome! !

!SoapServiceHandler methodsFor: 'accessing' stamp: 'mu 9/5/2001 20:32'!
serviceHome: aValue

	serviceHome := aValue! !


!SoapServiceHandler methodsFor: 'private' stamp: 'MU 3/24/2002 02:55'!
createSignature: aSoapEnvelope
	| mElem name argNames sig |
	mElem := aSoapEnvelope body bodyEntries first.
	name := mElem shortName asSymbol. 
	argNames := mElem children
				collect: [:each | each shortName asSymbol].
	sig := SoapServiceSignature name: name paramNames: argNames.
	mElem children do: [:each | sig valueAt: each shortName asSymbol put: (self extractDecodedValueFrom: each ) ].
	^sig! !

!SoapServiceHandler methodsFor: 'private' stamp: 'mu 10/13/2001 19:58'!
extractDecodedValueFrom: aSoapWrapElement
	| decoder |
	decoder := SoapDecoderFactory createFrom: aSoapWrapElement encodingStyleURIs.
	^decoder decodeXmlElement: aSoapWrapElement! !

!SoapServiceHandler methodsFor: 'private' stamp: 'mu 1/9/2002 22:44'!
findService: aSoapEnvelope 
	| mElement nm key  serv |
	mElement := aSoapEnvelope body bodyEntries first.
	nm := mElement shortName.
	key := self context targetObjectURI isEmpty
		ifTrue: [nm]
		ifFalse: [self context targetObjectURI , ':' , nm].
	serv := self serviceHome at: key.
	^ serv! !

!SoapServiceHandler methodsFor: 'private' stamp: 'MU 10/25/2002 02:07'!
invoke: aSoapEnvelope
	
	| service signature ret |
	service := self findService: aSoapEnvelope.
	signature := self createSignature: aSoapEnvelope.
	self class showLog ifTrue: [Transcript cr; show: '[service invoked@', Time now printString , '] ', service printString].
	ret := service invoke: signature.
	self class showLog ifTrue: [Transcript cr; show: '-> [return value] ', ret printString].
	^ret
	
	
	! !

!SoapServiceHandler methodsFor: 'private' stamp: 'mu 1/27/2002 01:05'!
invoke: aSoapEnvelope with: aSoapContext
	
	"##obsolete##" "for testing"
	self context: aSoapContext.
	^self invoke: aSoapEnvelope ! !

!SoapServiceHandler methodsFor: 'private' stamp: 'mu 1/27/2002 01:06'!
selectResponseEncoderFor: aMethodElement 
	^self class useResponseEncoder
		ifTrue: [self responseEncoder]
		ifFalse: [self context encodingStyleURIs isEmpty
				ifTrue: [SoapEncoderFactory createFrom: aMethodElement encodingStyleURIs]
				ifFalse: [SoapEncoderFactory createFrom: self context encodingStyleURIs]]! !

!SoapServiceHandler methodsFor: 'private' stamp: 'mu 1/27/2002 01:03'!
wrapError: anError
	| body fault errorName |
	body := self envelope body.
	body clearBodyEntries.
	fault := body addFault.
	self faultDetailBuilder buildSoapFaultDetailOn: fault from: anError.
	errorName := anError class name.
	(#(#SoapNoSuchService #SoapInvalidParamName #SoapDecodingError) includes: errorName)
		ifTrue: [fault client]
		ifFalse: [fault server].
	^ self envelope! !

!SoapServiceHandler methodsFor: 'private' stamp: 'mu 1/27/2002 01:04'!
wrapResult: aResultObject
	|  methodElem resultTagName nsPref nsURI resultMethodElem encoder respElem |
	methodElem := self envelope body bodyEntries first.
	resultTagName := methodElem name , 'Response'.
	nsPref := methodElem declaredNamespacePrefixes asArray first.
	nsURI := methodElem declaredNamespaceURIFor: nsPref.
	resultMethodElem := self xmlElementClass named: resultTagName.
	resultMethodElem declareNamespace: nsPref uri: nsURI.
	
	encoder := self context encodingStyleURIs isEmpty ifFalse: [SoapEncoderFactory createFrom: self context encodingStyleURIs]
				ifTrue: [ SoapEncoderFactory createFrom: methodElem encodingStyleURIs].
    
	respElem := encoder
				encodeSoapVariable: (SoapVariable name: (SoapConstants returnValueAccessor) value: aResultObject).
	resultMethodElem addChild: respElem.

	self envelope body clearBodyEntries.
	self envelope body addBodyEntry: resultMethodElem.
	^ self envelope! !

!SoapServiceHandler methodsFor: 'private' stamp: 'mu 1/27/2002 01:07'!
wrapResult: aResultObject using: aSoapEnvelope 
	|  methodElem resultTagName nsPref nsURI resultMethodElem encoder respElem |
	methodElem := aSoapEnvelope body bodyEntries first.
	resultTagName := methodElem name , 'Response'.
	nsPref := methodElem declaredNamespacePrefixes asArray first.
	nsURI := methodElem declaredNamespaceURIFor: nsPref.
	resultMethodElem := self xmlElementClass named: resultTagName.
	resultMethodElem declareNamespace: nsPref uri: nsURI.
	
	encoder := self selectResponseEncoderFor: methodElem. 
    
	respElem := encoder
				encodeSoapVariable: (SoapVariable name: (SoapConstants returnValueAccessor) value: aResultObject).
	resultMethodElem addChild: respElem.

	aSoapEnvelope body clearBodyEntries.
	aSoapEnvelope body addBodyEntry: resultMethodElem.
	^ aSoapEnvelope! !


!SoapServiceHandler methodsFor: 'factory' stamp: 'mu 1/1/2002 20:19'!
xmlElementClass
	^SoapWrapElement! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapServiceHandler class
	instanceVariableNames: 'defaultResponseEncoder handlerDict useResponseEncoder showLog useTestServiceHandler '!

!SoapServiceHandler class methodsFor: 'class initialization' stamp: 'mu 5/2/2003 18:44'!
initialize
	"SoapServiceHandler initialize"
	showLog := false.
	defaultResponseEncoder := handlerDict := nil.
	useResponseEncoder := useTestServiceHandler := nil.
	
	! !


!SoapServiceHandler class methodsFor: 'instance creation' stamp: 'mu 5/2/2003 18:46'!
default
	| handlerName |
	handlerName := self useTestServiceHandler ifTrue: [#test] ifFalse: [#default].
	^self named: handlerName! !

!SoapServiceHandler class methodsFor: 'instance creation' stamp: 'mu 11/10/2001 20:13'!
named: aSymbol
	^self handlerDict at: aSymbol ifAbsentPut: [self new]
	! !


!SoapServiceHandler class methodsFor: 'actions' stamp: 'mu 11/10/2001 20:14'!
deleteNamed: aSymbol
	^self handlerDict removeKey: aSymbol ifAbsent: []
	! !


!SoapServiceHandler class methodsFor: 'accessing' stamp: 'mu 1/4/2002 23:09'!
defaultResponseEncoder
	defaultResponseEncoder isNil ifTrue: [defaultResponseEncoder := SoapEncoder new].
	^defaultResponseEncoder! !

!SoapServiceHandler class methodsFor: 'accessing' stamp: 'mu 1/4/2002 23:10'!
defaultResponseEncoder: aSoapAbstractEncoder
	defaultResponseEncoder := SoapAbstractEncoder! !

!SoapServiceHandler class methodsFor: 'accessing' stamp: 'mu 10/27/2001 19:09'!
handlerDict
	handlerDict isNil ifTrue: [handlerDict := IdentityDictionary new].
	^handlerDict! !

!SoapServiceHandler class methodsFor: 'accessing' stamp: 'mu 10/27/2001 19:09'!
handlerDict: aDictionary
	handlerDict := aDictionary! !

!SoapServiceHandler class methodsFor: 'accessing' stamp: 'mu 1/27/2002 00:58'!
useResponseEncoder
	useResponseEncoder isNil ifTrue: [useResponseEncoder := false].
	^useResponseEncoder! !

!SoapServiceHandler class methodsFor: 'accessing' stamp: 'mu 1/27/2002 00:57'!
useResponseEncoder: aBoolean
	useResponseEncoder := aBoolean! !

!SoapServiceHandler class methodsFor: 'accessing' stamp: 'mu 5/2/2003 18:44'!
useTestServiceHandler
	useTestServiceHandler isNil ifTrue:[useTestServiceHandler := false].
	^useTestServiceHandler! !

!SoapServiceHandler class methodsFor: 'accessing' stamp: 'mu 5/2/2003 18:44'!
useTestServiceHandler: aBoolean
	useTestServiceHandler := aBoolean! !


!SoapServiceHandler class methodsFor: 'utilities' stamp: 'MU 10/25/2002 01:17'!
defaultServiceHome
	"SoapServiceHandler defaultServiceHome"
	^self default serviceHome! !

!SoapServiceHandler class methodsFor: 'utilities' stamp: 'MU 10/25/2002 01:29'!
showLog
	showLog isNil ifTrue: [showLog := false].
	^showLog! !

!SoapServiceHandler class methodsFor: 'utilities' stamp: 'MU 10/25/2002 01:29'!
showLog: aBoolean
	"SoapServiceHandler showLog: true"
	"SoapServiceHandler showLog: false"
	showLog := aBoolean! !


Object subclass: #SoapServiceHome
	instanceVariableNames: 'objectDict '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-ServerBase'!

!SoapServiceHome methodsFor: 'initialize-release' stamp: 'mu 9/24/2001 01:57'!
initialize
	objectDict := self defaultDictionary.
	! !


!SoapServiceHome methodsFor: 'actions' stamp: 'mu 8/29/2003 16:51'!
at: serviceKey
	serviceKey isNil ifTrue:[^nil].
	^ objectDict at: serviceKey ifAbsent:[SoapNoSuchService signal: serviceKey]! !

!SoapServiceHome methodsFor: 'actions' stamp: 'mu 8/29/2003 16:52'!
at: serviceKey ifAbsent: aBlock
	serviceKey isNil ifTrue:[^nil].
	^ objectDict at: serviceKey ifAbsent: aBlock! !

!SoapServiceHome methodsFor: 'actions' stamp: 'mu 8/29/2003 16:52'!
at: serviceKey ifAbsentPut: aBlock
	serviceKey isNil ifTrue:[^nil].
	^ objectDict at: serviceKey ifAbsentPut: aBlock! !

!SoapServiceHome methodsFor: 'actions' stamp: 'mu 8/29/2003 16:52'!
at: serviceKey put: anObject 
	serviceKey isNil ifTrue:[^nil].
	^ objectDict at: serviceKey put: anObject! !

!SoapServiceHome methodsFor: 'actions' stamp: 'mu 8/29/2003 16:52'!
removeKey: serviceKey 
	serviceKey isNil ifTrue:[^nil].
	^ objectDict removeKey: serviceKey ! !

!SoapServiceHome methodsFor: 'actions' stamp: 'mu 8/29/2003 16:52'!
removeKey: serviceKey ifAbsent: aBlock
	serviceKey isNil ifTrue:[^nil].
	^ objectDict removeKey: serviceKey ifAbsent: aBlock! !

!SoapServiceHome methodsFor: 'actions' stamp: 'mu 8/29/2003 16:52'!
serviceKeys
	^objectDict keys asArray! !


!SoapServiceHome methodsFor: 'printing' stamp: 'MU 10/25/2002 01:24'!
printOn: aStream
	super printOn: aStream.
	aStream nextPutAll: ' { '.
	objectDict keysAndValuesDo:[:key :value |
		 aStream cr; tab; print: key; nextPutAll: '->'; print: value].
	aStream nextPutAll: ' } '.! !


!SoapServiceHome methodsFor: 'factory' stamp: 'mu 9/24/2001 01:57'!
defaultDictionary
	^Dictionary new! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapServiceHome class
	instanceVariableNames: ''!

!SoapServiceHome class methodsFor: 'instance creation' stamp: 'mu 7/22/2001 23:23'!
new
	^super new initialize! !


Object subclass: #SoapServiceSignature
	instanceVariableNames: 'name paramNames paramValues '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-ServerBase'!

!SoapServiceSignature methodsFor: 'actions' stamp: 'mu 11/10/2001 21:30'!
nameExists: aParamName
	^self paramNames includes: aParamName! !

!SoapServiceSignature methodsFor: 'actions' stamp: 'mu 11/10/2001 21:05'!
valueAt: aParamName
	^self paramValues at: aParamName ifAbsent: [SoapInvalidParamName signal: aParamName]! !

!SoapServiceSignature methodsFor: 'actions' stamp: 'mu 1/1/2002 19:28'!
valueAt: aParamName ifAbsent: aBlock
	^self paramValues at: aParamName ifAbsent: aBlock! !

!SoapServiceSignature methodsFor: 'actions' stamp: 'mu 11/10/2001 21:23'!
valueAt: aParamName put: aParamValue 
	(self paramNames includes: aParamName)
		ifTrue: [self paramValues at: aParamName put: aParamValue]
		ifFalse: [SoapInvalidParamName signal: aParamName]! !

!SoapServiceSignature methodsFor: 'actions' stamp: 'mu 11/10/2001 21:33'!
verify: aSoapServiceSignature
	aSoapServiceSignature paramNames do: [:each | (self nameExists: each) ifFalse:[SoapInvalidParamName signal: each]].
	^true! !


!SoapServiceSignature methodsFor: 'accessing' stamp: 'mu 9/18/2001 20:22'!
name

	^name! !

!SoapServiceSignature methodsFor: 'accessing' stamp: 'mu 9/18/2001 20:23'!
name: aValue

	name := aValue! !

!SoapServiceSignature methodsFor: 'accessing' stamp: 'mu 9/6/2001 00:54'!
paramNames

	^paramNames! !

!SoapServiceSignature methodsFor: 'accessing' stamp: 'mu 9/6/2001 00:54'!
paramNames: aValue

	paramNames := aValue! !

!SoapServiceSignature methodsFor: 'accessing' stamp: 'mu 9/6/2001 01:06'!
paramValues
	paramValues isNil ifTrue: [paramValues := IdentityDictionary new].
	^paramValues! !

!SoapServiceSignature methodsFor: 'accessing' stamp: 'mu 9/6/2001 00:54'!
paramValues: aValue

	paramValues := aValue! !


!SoapServiceSignature methodsFor: 'printing' stamp: 'mu 12/27/2001 23:42'!
printOn: aStream 
	aStream print: self name.
	aStream nextPutAll: ' ( '.
	aStream print: self paramNames.
	aStream nextPutAll: ' ) '.
	self paramValues isEmpty
		ifFalse: [aStream nextPutAll: ' < '.
			aStream print: self paramValues.
			aStream nextPutAll: ' > ']! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapServiceSignature class
	instanceVariableNames: ''!

!SoapServiceSignature class methodsFor: 'instance creation' stamp: 'mu 12/28/2001 02:38'!
name: aServiceName 
	^ self new name: aServiceName;
		 paramNames: #()! !

!SoapServiceSignature class methodsFor: 'instance creation' stamp: 'mu 9/18/2001 21:32'!
name: aServiceName paramNames: anArrayOfParamNames 
	^ self new name: aServiceName;
		 paramNames: anArrayOfParamNames! !

SoapServerSetup initialize!
SoapServiceHandler initialize!