SoapAbstractSocketClient subclass: #SoapSqtpClient
	instanceVariableNames: 'soapEnvelope messageArray '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Sqtp-Client'!

!SoapSqtpClient methodsFor: 'private' stamp: 'MU 8/26/2002 18:07'!
host: hostnameString port: portNumberInteger page: pageString 
	host := hostnameString.
	port := portNumberInteger.
	reqURI := pageString.! !


!SoapSqtpClient methodsFor: 'actions-hooks'!
getResponseContents
	| object |
	object := SoapSqtpProtocol getObjectFrom: socket.
	
	self class showLog
		ifTrue: [Transcript cr; show: '##' , super printString , ' Client:Return:{'.
			Transcript show: object printString, '}'].
	
	^ object! !

!SoapSqtpClient methodsFor: 'actions-hooks'!
prepareAdditionals
	messageArray := Array with: reqURI with: soapEnvelope.
	! !

!SoapSqtpClient methodsFor: 'actions-hooks'!
prepareEnvelope: aSoapEnvelope
	soapEnvelope :=  aSoapEnvelope
	! !

!SoapSqtpClient methodsFor: 'actions-hooks' stamp: 'mu 9/8/2003 00:53'!
prepareSocket
	socket := Socket new.
	[socket
		connectTo: serverAddress
		port: port
		waitForConnectionFor: self class connectionTimeout]
		on: ConnectionTimedOut
		do: [:ex | SoapCannotConnectToServer signal: 'Server does not respond - ''host: ' , host , ' port: ' , port printString]! !

!SoapSqtpClient methodsFor: 'actions-hooks'!
sendBySocket
	
	SoapSqtpProtocol sendRequestObject: messageArray by: socket! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapSqtpClient class
	instanceVariableNames: ''!

!SoapSqtpClient class methodsFor: 'class initialization' stamp: 'MU 8/26/2002 15:13'!
initialize
	"SoapSqtpClient initialize"
	showLog := false.

	! !


!SoapSqtpClient class methodsFor: 'instance creation' stamp: 'MU 8/26/2002 18:05'!
host: hostnameString port: portNumberInteger page: pageString 
	| reqURI |
	reqURI := (pageString isNil
					or: [pageString isEmpty])
				ifTrue: ['/']
				ifFalse: [pageString].
	^ self new
		host: hostnameString
		port: portNumberInteger
		page: reqURI! !


SoapAbstractConnector subclass: #SoapSqtpConnector
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOAP-Sqtp-Client'!

!SoapSqtpConnector methodsFor: 'actions' stamp: 'MU 4/18/2003 16:08'!
send: aSoapEnvelope to: anSoapTcpLocator with: aSoapContext 
	| soapClient returnEnvelope |
	self
		debugSend: aSoapEnvelope
		to: anSoapTcpLocator
		with: aSoapContext.
	[soapClient := SoapSqtpClient
				host: anSoapTcpLocator host
				port: anSoapTcpLocator port
				page: aSoapContext targetObjectURI.
	returnEnvelope := soapClient send: aSoapEnvelope]
		on: SoapCannotResolveServer , SoapCannotConnectToServer , SoapSqtpGenericError
		do: [:ex | returnEnvelope := self envelopeBuilder buildClientSoapFaultEnvelope: ex].
	^ SoapMessage envelope: returnEnvelope! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoapSqtpConnector class
	instanceVariableNames: ''!

!SoapSqtpConnector class methodsFor: 'class initialization' stamp: 'MU 10/5/2002 02:27'!
initialize
	self initializeAfterLoad! !


!SoapSqtpConnector class methodsFor: 'constants' stamp: 'mu 8/28/2002 17:03'!
transportName
	^#sqtp! !

SoapSqtpClient initialize!
SoapSqtpConnector initialize!