Object subclass: #SoExoboxXMLParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoXML-ParserAdapter'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoExoboxXMLParserAdapter class
	instanceVariableNames: ''!

!SoExoboxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/18/2002 01:37'!
attribDictFrom: aParsedXMLElement
	aParsedXMLElement isText ifTrue:[^Dictionary new].
	^aParsedXMLElement attributes! !

!SoExoboxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/18/2002 01:20'!
elementNameFrom: aParsedXMLElement
	"assuming Exobox"
	^aParsedXMLElement tag.
	! !

!SoExoboxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/18/2002 01:25'!
elementShortNameFrom: aParsedXMLElement
	^(SoXmlUtil prefixAndLocalNameFrom: (aParsedXMLElement tag)) last.
	! !

!SoExoboxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/18/2002 01:32'!
elementValueFrom: aParsedXMLElement
	| cData |
	cData := aParsedXMLElement charactersData.
	^cData isEmpty ifTrue: [nil] ifFalse: [cData]
	
	! !

!SoExoboxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/19/2002 03:39'!
elementsFrom: aParsedXMLElement
	
	^aParsedXMLElement contents.! !

!SoExoboxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/19/2002 03:44'!
elementsWithoutBlankTextsFrom: aParsedXMLElement
	aParsedXMLElement isText ifTrue:[^#()].
	^aParsedXMLElement contents reject: [:e | e isText and:[ SoPortableUtil isBlank: e text]].! !

!SoExoboxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/19/2002 03:41'!
elementsWithoutTextsFrom: aParsedXMLElement
	
	^aParsedXMLElement contents select: [:e | e isText not].! !

!SoExoboxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/18/2002 01:21'!
isTextElement: aParsedXMLElement
	^aParsedXMLElement isText! !

!SoExoboxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/18/2002 01:20'!
parseXml: xmlString
	"assuming Exobox"
	^(XMLReader fromString: xmlString) root
	! !


Object subclass: #SoVWXMLParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoXML-ParserAdapter'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoVWXMLParserAdapter class
	instanceVariableNames: ''!

!SoVWXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/17/2002 01:52'!
attribDictFrom: aParsedXMLElement
	"TODO: support multi parser"
	"assuming VWXML"
	| dict |
	dict := Dictionary new.
	aParsedXMLElement isText ifTrue:[^dict].
	aParsedXMLElement attributes do: [:each |
		dict add: (Association key: each tag asString value: each value)
	].
	^dict! !

!SoVWXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/17/2002 01:52'!
elementNameFrom: aParsedXMLElement
	"TODO: support multi parser"
	"assuming VWXML"
	^aParsedXMLElement tag asString.
	! !

!SoVWXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/17/2002 01:52'!
elementShortNameFrom: aParsedXMLElement
	"TODO: support multi parser"
	"assuming VWXML"
	^aParsedXMLElement tag type.
	! !

!SoVWXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/17/2002 01:52'!
elementValueFrom: aParsedXMLElement
	"TODO: support multi parser"
	"assuming VWXML"
	^aParsedXMLElement isText ifTrue: [aParsedXMLElement characterData] ifFalse:[nil].
	! !

!SoVWXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/17/2002 01:52'!
elementsFrom: aParsedXMLElement
	"TODO: support multi parser"
	"assuming VWXML"
	^aParsedXMLElement elements.! !

!SoVWXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/17/2002 01:52'!
elementsWithoutBlankTextsFrom: aParsedXMLElement
	"TODO: support multi parser"
	"assuming VWXML"
	aParsedXMLElement isText ifTrue:[^#()].
	^aParsedXMLElement elements reject: [:e | e isText and:[ SoPortableUtil isBlank: e characterData]].! !

!SoVWXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/17/2002 01:52'!
elementsWithoutTextsFrom: aParsedXMLElement
	"TODO: support multi parser"
	"assuming VWXML"
	^aParsedXMLElement elements select: [:e | e isText not].! !

!SoVWXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/17/2002 01:52'!
isTextElement: aParsedXMLElement
	"TODO: support multi parser"
	"assuming VWXML"
	^aParsedXMLElement isText! !

!SoVWXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 1/17/2002 01:52'!
parseXml: xmlString
	"TODO: support multi parser"
	"assuming VWXML"
	^(VWXMLXMLParser processDocumentString: xmlString beforeScanDo: [:p | p validate: false.]) root
	! !


Object subclass: #SoYaxXMLParserAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SoXML-ParserAdapter'!

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SoYaxXMLParserAdapter class
	instanceVariableNames: ''!

!SoYaxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 2/1/2002 00:34'!
attribDictFrom: aParsedXMLElement
	aParsedXMLElement isText ifTrue:[^Dictionary new].
	^aParsedXMLElement attributes! !

!SoYaxXMLParserAdapter class methodsFor: 'actions' stamp: 'mu 2/1/2002 00:49'!
elementNameFrom: aParsedXMLElement
	"assuming Yax"
	^aParsedXMLElement tag.
	! !

!SoYaxXMLParserAdapter class methodsFor: 'actions' stamp: 'MU 2/3/2002 02:31'!
elementShortNameFrom: aParsedXMLElement
	"assuming Yax"
	^(SoXmlUtil prefixAndLocalNameFrom: (aParsedXMLElement tag)) last.
	! !

!SoYaxXMLParserAdapter class methodsFor: 'actions' stamp: 'MU 2/3/2002 02:31'!
elementValueFrom: aParsedXMLElement
	"assuming Yax"
	| cData |
	cData := aParsedXMLElement characterData.
	^cData isEmpty ifTrue: [nil] ifFalse: [cData]
	
	! !

!SoYaxXMLParserAdapter class methodsFor: 'actions' stamp: 'MU 11/18/2002 01:15'!
elementsFrom: aParsedXMLElement 
	"assuming YAXO"
	^ aParsedXMLElement elements,  aParsedXMLElement contents! !

!SoYaxXMLParserAdapter class methodsFor: 'actions' stamp: 'MU 11/18/2002 01:22'!
elementsWithoutBlankTextsFrom: aParsedXMLElement 
	"assuming YAXO"
	^ aParsedXMLElement elements
		, (aParsedXMLElement contents
				reject: [:each | SoPortableUtil isBlank: each characterData])! !

!SoYaxXMLParserAdapter class methodsFor: 'actions' stamp: 'MU 11/18/2002 01:17'!
elementsWithoutTextsFrom: aParsedXMLElement
	"assuming YAXO"
	^aParsedXMLElement elements! !

!SoYaxXMLParserAdapter class methodsFor: 'actions' stamp: 'MU 2/3/2002 02:32'!
isTextElement: aParsedXMLElement 
	"assuming Yax"
	^ aParsedXMLElement isText! !

!SoYaxXMLParserAdapter class methodsFor: 'actions' stamp: 'MU 11/18/2002 01:01'!
parseXml: xmlString
	"assuming Yax"
	^(XMLDOMParser parseDocumentFrom: (ReadStream on: xmlString)) topElement
	! !
