"Description: 
An install script for SoapCore 0.6 Client
Edit settings and file-in.

Copyright (C) 2002-2003 Masashi Umezawa

Prerequisites:
YAXO or VWXML

How to install: 
1: Create a new directory named: 'installSoapOpera0.6' under your Squeak home direcotry.
2: Copy all needed files to the directory. (installSoapCoreClientOnly.st, [SoapCore])
3: From the file list, just file in this file.

"!

"settings -  edit if you like"
dir := 'installSoapOpera0.6'.
soapInstall := true.
soapSrpEncInstall := false.
soapSqtpTransInstall := true.
sixxEncInstall := false.

"install main - edit if you like (normally you don't have to)"
rootPath := (FileDirectory default fullNameFor: dir), FileDirectory slash.
soapPath := rootPath,'SoapCore'.

soapCoreMiniSets := #(
'SoXML-Base.st'
'SoXML-ParserAdapter.st'
'SOAP-Base.st'
'SOAP-Elements.st'
'SOAP-DataBinding.st'
'SOAP-Encoding.st'
'SOAP-Decoding.st'
'SOAP-ClientBase.st'
'SOAP-Http.st'
'SOAP-Http-Client.st'
'SOAP-RPC.st'
'SOAP-Example.st'
'SOAP-GoogleWebAPI.st'
).

soapSrpEnc := #(
'SOAP-DataBinding-SRP.st'
).

soapSixxEnc := #(
'SOAP-DataBinding-SIXX.st'
).

soapSqtpTrans := #(
'SOAP-Sqtp.st'
'SOAP-Sqtp-Client.st'
).

soapInstall ifTrue:[
soapCoreMiniSets do:[:each | ((FileDirectory on: soapPath) readOnlyFileNamed: each) fileIn.].
].

soapSrpEncInstall ifTrue:[
soapSrpEnc do:[:each | ((FileDirectory on: soapPath) readOnlyFileNamed: each) fileIn.].
].

soapSqtpTransInstall ifTrue:[
soapSqtpTrans do:[:each | ((FileDirectory on: soapPath) readOnlyFileNamed: each) fileIn.].
].

sixxEncInstall ifTrue: [
soapSixxEnc do:[:each | ((FileDirectory on: soapPath) readOnlyFileNamed: each) fileIn.].
].
!

"program initialization"

(Smalltalk includesKey: #VWXMLXMLParser) ifTrue:[
(self confirm: 'Do you use VWXML? (No means YAXO)')
	ifTrue: [SoXmlUtil parserAdapter: SoVWXMLParserAdapter ].
].
SoapConfigurationMap initializeAll.

self inform: 'SoapCore0.6 client installation succeeded'.
ChangeSet current name: 'SoapCore0.6-20031010-client'.
! 

"end of script"!
